# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`icinga2`](#icinga2): This module installs and configures Icinga 2.
* [`icinga2::feature::api`](#icinga2--feature--api): Configures the Icinga 2 feature api.
* [`icinga2::feature::checker`](#icinga2--feature--checker): Configures the Icinga 2 feature checker.
* [`icinga2::feature::command`](#icinga2--feature--command): Configures the Icinga 2 feature command.
* [`icinga2::feature::compatlog`](#icinga2--feature--compatlog): Configures the Icinga 2 feature compatlog.
* [`icinga2::feature::debuglog`](#icinga2--feature--debuglog): Configures the Icinga 2 feature mainlog.
* [`icinga2::feature::elasticsearch`](#icinga2--feature--elasticsearch): Configures the Icinga 2 feature elasticsearch.
* [`icinga2::feature::gelf`](#icinga2--feature--gelf): Configures the Icinga 2 feature gelf.
* [`icinga2::feature::graphite`](#icinga2--feature--graphite): Configures the Icinga 2 feature graphite.
* [`icinga2::feature::icingadb`](#icinga2--feature--icingadb): Configures the Icinga 2 feature icingadb.
* [`icinga2::feature::idomysql`](#icinga2--feature--idomysql): Installs and configures the Icinga 2 feature ido-mysql.
* [`icinga2::feature::idopgsql`](#icinga2--feature--idopgsql): Installs and configures the Icinga 2 feature ido-pgsql.
* [`icinga2::feature::influxdb`](#icinga2--feature--influxdb): Configures the Icinga 2 feature influxdb.
* [`icinga2::feature::influxdb2`](#icinga2--feature--influxdb2): Configures the Icinga 2 feature influxdb2.
* [`icinga2::feature::livestatus`](#icinga2--feature--livestatus): Configures the Icinga 2 feature livestatus.
* [`icinga2::feature::mainlog`](#icinga2--feature--mainlog): Configures the Icinga 2 feature mainlog.
* [`icinga2::feature::notification`](#icinga2--feature--notification): Configures the Icinga 2 feature notification.
* [`icinga2::feature::opentsdb`](#icinga2--feature--opentsdb): Configures the Icinga 2 feature opentsdb.
* [`icinga2::feature::perfdata`](#icinga2--feature--perfdata): Configures the Icinga 2 feature perfdata.
* [`icinga2::feature::statusdata`](#icinga2--feature--statusdata): Configures the Icinga 2 feature statusdata.
* [`icinga2::feature::syslog`](#icinga2--feature--syslog): Configures the Icinga 2 feature syslog.
* [`icinga2::feature::windowseventlog`](#icinga2--feature--windowseventlog): Configures the Icinga 2 feature windowseventlog.
* [`icinga2::pki::ca`](#icinga2--pki--ca): This class provides multiple ways to create the CA used by Icinga 2.
* [`icinga2::query_objects`](#icinga2--query_objects): Class to query `icinga2::objects` from puppetdb.

#### Private Classes

* `icinga2::config`: This class exists to manage general configuration files needed by Icinga 2 to run.
* `icinga2::globals`: This class loads the default parameters by doing a hiera lookup.
* `icinga2::install`: This class handles the installation of the Icinga 2 package.
On Windows only chocolatey is supported as installation source.
* `icinga2::service`: This class handles the Icinga 2 service. By default the service will
start on boot and will be restarted if stopped.

### Defined types

#### Public Defined types

* [`icinga2::config::fragment`](#icinga2--config--fragment): Set a code fragment in a target configuration file. It's not possible to add a fragment to an object.
* [`icinga2::object::apiuser`](#icinga2--object--apiuser): Manage Icinga 2 ApiUser objects.
* [`icinga2::object::checkcommand`](#icinga2--object--checkcommand): Manage Icinga 2 Host objects.
* [`icinga2::object::checkresultreader`](#icinga2--object--checkresultreader): Manage Icinga 2 CheckResultReader objects.
* [`icinga2::object::dependency`](#icinga2--object--dependency): Manage Icinga 2 dependency objects.
* [`icinga2::object::endpoint`](#icinga2--object--endpoint): Manage Icinga 2 endpoint objects.
* [`icinga2::object::eventcommand`](#icinga2--object--eventcommand): Manage Icinga 2 EventCommand objects.
* [`icinga2::object::host`](#icinga2--object--host): Manage Icinga 2 Host objects.
* [`icinga2::object::hostgroup`](#icinga2--object--hostgroup): Manage Icinga 2 HostGroup objects.
* [`icinga2::object::icingaapplication`](#icinga2--object--icingaapplication): Manage Icinga 2 IcingaApplication objects.
* [`icinga2::object::notification`](#icinga2--object--notification): Manage Icinga 2 notification objects.
* [`icinga2::object::notificationcommand`](#icinga2--object--notificationcommand): Manage Icinga 2 notificationcommand objects.
* [`icinga2::object::scheduleddowntime`](#icinga2--object--scheduleddowntime): Manage Icinga 2 scheduleddowntime objects.
* [`icinga2::object::service`](#icinga2--object--service): Manage Icinga 2 service objects.
* [`icinga2::object::servicegroup`](#icinga2--object--servicegroup): Manage Icinga 2 servicegroup objects.
* [`icinga2::object::timeperiod`](#icinga2--object--timeperiod): Manage Icinga 2 timeperiod objects.
* [`icinga2::object::user`](#icinga2--object--user): Manage Icinga 2 user objects.
* [`icinga2::object::usergroup`](#icinga2--object--usergroup): Manage Icinga 2 usergroup objects.
* [`icinga2::object::zone`](#icinga2--object--zone): Manage Icinga 2 zone objects.

#### Private Defined types

* `icinga2::feature`: Private define resource to used by this module only.
* `icinga2::object`: Define resource to used by this module only.
* `icinga2::tls::client`: A class to generate tls key, cert and cacert paths.

### Functions

* [`icinga2::cert`](#icinga2--cert): Choose the path of tls key, cert and ca file.
* [`icinga2::db::connect`](#icinga2--db--connect): This function returns a string to connect databases
with or without TLS information.
* [`icinga2::icinga2_attributes`](#icinga2--icinga2_attributes): Calls the simple parser  to decide what to quote.
For more information, see lib/puppet_x/icinga2/utils.rb.
* [`icinga2::icinga2_ticket_id`](#icinga2--icinga2_ticket_id): Summarise what the function does here
* [`icinga2::newline`](#icinga2--newline): Replace newlines for Windows systems.
* [`icinga2::parse`](#icinga2--parse)
* [`icinga2::unwrap`](#icinga2--unwrap): This function returns an unwrap string if necessary.

### Data types

* [`Icinga2::BasicAuth`](#Icinga2--BasicAuth): A strict type for basic authentication
* [`Icinga2::CustomAttributes`](#Icinga2--CustomAttributes): A type for the structure of custom attributes
* [`Icinga2::Fingerprint`](#Icinga2--Fingerprint): Type for certificate fingerprints SHA1: 160 bit (20 byte) digest SHA256: 256 bit (32 byte) digest
* [`Icinga2::IdoCleanup`](#Icinga2--IdoCleanup): A type for the structure of settings to cleanup IDO databases
* [`Icinga2::Interval`](#Icinga2--Interval): A strict type for intervals
* [`Icinga2::LogFacility`](#Icinga2--LogFacility): A strict type of syslog facilities
* [`Icinga2::LogSeverity`](#Icinga2--LogSeverity): A strict type for log levels

## Classes

### <a name="icinga2"></a>`icinga2`

This module installs and configures Icinga 2.

* **Note** Setting manage_packages to false means that all package aren't handeld by the module included the IDO packages.

#### Examples

##### Declare icinga2 with all defaults. Keep in mind that your operating system may not have Icinga 2 in its package repository.

```puppet

include icinga2
```

##### If you want to use the module icinga/puppet-icinga, e.g. to use the official Icinga Project repositories, enable the manage_repos parameter.

```puppet
class { 'icinga2':
  manage_repos => true,
}
```

##### If you don't want to manage the Icinga 2 service with puppet, you can dissable this behaviour with the manage_service parameter. When set to false no service refreshes will be triggered.

```puppet
class { 'icinga2':
  manage_service => false,
}
```

##### To manage the version of Icinga 2 binaries you can do it by disable package management:

```puppet
package { 'icinga2':
  ensure  => latest,
  notifiy => Class['icinga2'],
}

class { 'icinga2':
  manage_packages => false,
}
```

##### To set constants in etc/icinga2/constants.conf use the constants parameter and as value a hash, every key will be set as constant and assigned by it's value. Defaults can be overwritten.

```puppet
class { 'icinga2':
  ...
  constants   => {
    'key1'             => 'value1',
    'key2'             => 'value2',
    'PluginContirbDir' => '/usr/local/nagios/plugins',
  }
}
```

##### Enabling features with there defaults or loading parameters via Hiera:

```puppet
class { 'icinga2':
  manage_repos => true,
  features     => ['checker', 'mainlog', 'command'],
}
```

##### The ITL contains several CheckCommand definitions to load, set these in the array of the plugins parameter, i.e. for a master or satellite do the following and disbale the load of the configuration in conf.d.

```puppet
class { 'icinga':
  ...
  plugins => [ 'plugins', 'contrib-plugins', 'nscp', 'windows-plugins' ],
  confd   => false,
}
```

##### Sometimes it's necessary to cover very special configurations that you cannot handle with this module. In this case you can use the icinga2::config::file tag on your file resource. This module collects all file resource types with this tag and triggers a reload of Icinga 2 on a file change.

```puppet
include ::icinga2

file { '/etc/icinga2/conf.d/foo.conf':
  ensure => file,
  owner  => icinga,
  ...
  tag    => 'icinga2::config::file',
  ...
}
```

##### To use a different directory for your configuration, create the directory as file resource with tag icinga2::config::file.

```puppet
file { '/etc/icinga2/local.d':
  ensure => directory,
  tag    => 'icinga2::config::file'
}
class { 'icinga2':
  ...
  confd => 'local.d',
}
```

#### Parameters

The following parameters are available in the `icinga2` class:

* [`ensure`](#-icinga2--ensure)
* [`enable`](#-icinga2--enable)
* [`manage_repos`](#-icinga2--manage_repos)
* [`manage_packages`](#-icinga2--manage_packages)
* [`manage_selinux`](#-icinga2--manage_selinux)
* [`manage_service`](#-icinga2--manage_service)
* [`features`](#-icinga2--features)
* [`purge_features`](#-icinga2--purge_features)
* [`constants`](#-icinga2--constants)
* [`plugins`](#-icinga2--plugins)
* [`confd`](#-icinga2--confd)

##### <a name="-icinga2--ensure"></a>`ensure`

Data type: `Stdlib::Ensure::Service`

Manages if the service should be stopped or running.

Default value: `running`

##### <a name="-icinga2--enable"></a>`enable`

Data type: `Boolean`

If set to true the Icinga 2 service will start on boot.

Default value: `true`

##### <a name="-icinga2--manage_repos"></a>`manage_repos`

Data type: `Boolean`

When set to true this module will use the module icinga/puppet-icinga to manage repositories,
e.g. the release repo on packages.icinga.com repository by default, the EPEL repository or Backports.
For more information, see http://github.com/icinga/puppet-icinga.

Default value: `false`

##### <a name="-icinga2--manage_packages"></a>`manage_packages`

Data type: `Boolean`

If set to false packages aren't managed.

Default value: `true`

##### <a name="-icinga2--manage_selinux"></a>`manage_selinux`

Data type: `Boolean`

If set to true the icinga selinux package is installed. Requires a `selinux_package_name` (icinga2::globals)
and `manage_packages` has to be set to true.

Default value: `false`

##### <a name="-icinga2--manage_service"></a>`manage_service`

Data type: `Boolean`

If set to true the service is managed otherwise the service also
isn't restarted if a config file changed.

Default value: `true`

##### <a name="-icinga2--features"></a>`features`

Data type: `Array`

List of features to activate. Defaults to [checker, mainlog, notification].

##### <a name="-icinga2--purge_features"></a>`purge_features`

Data type: `Boolean`

Define if configuration files for features not managed by Puppet should be purged.

Default value: `true`

##### <a name="-icinga2--constants"></a>`constants`

Data type: `Hash`

Hash of constants. Defaults are set in the params class. Your settings will be merged with the defaults.

Default value: `{}`

##### <a name="-icinga2--plugins"></a>`plugins`

Data type: `Array`

A list of the ITL plugins to load. Defaults to [ 'plugins', 'plugins-contrib', 'windows-plugins', 'nscp' ].

##### <a name="-icinga2--confd"></a>`confd`

Data type: `Variant[Boolean, String]`

`conf.d` is the directory where Icinga 2 stores its object configuration by default. To disable it,
set this parameter to `false`. By default this parameter is `true`. It's also possible to assign your
own directory. This directory must be managed outside of this module as file resource
with tag icinga2::config::file.

Default value: `true`

### <a name="icinga2--feature--api"></a>`icinga2::feature::api`

Configures the Icinga 2 feature api.

#### Examples

##### Use the puppet certificates and key copy these files to the cert directory named to 'hostname.key', 'hostname.crt' and 'ca.crt' if the contant NodeName is set to 'hostname'.

```puppet
include icinga2::feature::api
```

##### To use your own certificates and key as file resources if the contant NodeName is set to fqdn (default) do:

```puppet
class { 'icinga2::feature::api':
  pki => 'none',
}

File {
  owner => 'icinga',
  group => 'icinga',
}

file { "/var/lib/icinga2/certs/${::fqdn}.key":
  ensure => file,
  tag    => 'icinga2::config::file',
  source => "puppet:///modules/profiles/private_keys/${::fqdn}.key",
}
...
```

##### If you like to manage the certificates and the key as strings in base64 encoded format:

```puppet
class { 'icinga2::feature::api':
  pki         => 'none',
  ssl_cacert  => '-----BEGIN CERTIFICATE----- ...',
  ssl_key     => '-----BEGIN RSA PRIVATE KEY----- ...',
  ssl_cert    => '-----BEGIN CERTIFICATE----- ...',
}
```

##### Fine tune TLS settings

```puppet
class { 'icinga2::feature::api':
  ssl_protocolmin => 'TLSv1.2',
  ssl_cipher_list => 'HIGH:MEDIUM:!aNULL:!MD5:!RC4',
}
```

##### Transfer a CA certificate and key from an existing CA by using the file resource:

```puppet
include icinga2

file { '/var/lib/icinga2/ca/ca.crt':
  source => '...',
  tag    => 'icinga2::config::file',
}

file { '/var/lib/icinga2/ca/ca.key':
  source => '...',
  tag    => 'icinga2::config::file',
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::api` class:

* [`ensure`](#-icinga2--feature--api--ensure)
* [`pki`](#-icinga2--feature--api--pki)
* [`ssl_key`](#-icinga2--feature--api--ssl_key)
* [`ssl_cert`](#-icinga2--feature--api--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--api--ssl_cacert)
* [`ssl_crl`](#-icinga2--feature--api--ssl_crl)
* [`accept_config`](#-icinga2--feature--api--accept_config)
* [`accept_commands`](#-icinga2--feature--api--accept_commands)
* [`max_anonymous_clients`](#-icinga2--feature--api--max_anonymous_clients)
* [`ca_host`](#-icinga2--feature--api--ca_host)
* [`ca_port`](#-icinga2--feature--api--ca_port)
* [`fingerprint`](#-icinga2--feature--api--fingerprint)
* [`ticket_salt`](#-icinga2--feature--api--ticket_salt)
* [`ticket_id`](#-icinga2--feature--api--ticket_id)
* [`endpoints`](#-icinga2--feature--api--endpoints)
* [`zones`](#-icinga2--feature--api--zones)
* [`ssl_protocolmin`](#-icinga2--feature--api--ssl_protocolmin)
* [`ssl_handshake_timeout`](#-icinga2--feature--api--ssl_handshake_timeout)
* [`connect_timeout`](#-icinga2--feature--api--connect_timeout)
* [`ssl_cipher_list`](#-icinga2--feature--api--ssl_cipher_list)
* [`bind_host`](#-icinga2--feature--api--bind_host)
* [`bind_port`](#-icinga2--feature--api--bind_port)
* [`access_control_allow_origin`](#-icinga2--feature--api--access_control_allow_origin)
* [`access_control_allow_credentials`](#-icinga2--feature--api--access_control_allow_credentials)
* [`access_control_allow_headers`](#-icinga2--feature--api--access_control_allow_headers)
* [`access_control_allow_methods`](#-icinga2--feature--api--access_control_allow_methods)
* [`environment`](#-icinga2--feature--api--environment)

##### <a name="-icinga2--feature--api--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature api, absent disabled it.

Default value: `present`

##### <a name="-icinga2--feature--api--pki"></a>`pki`

Data type: `Enum['ca', 'icinga2', 'none', 'puppet']`

Provides multiple sources for the certificate, key and ca.
- puppet: Copies the key, cert and CAcert from the Puppet ssl directory to the cert directory
          /var/lib/icinga2/certs on Linux and C:/ProgramData/icinga2/var/lib/icinga2/certs on Windows.
          Please note that Puppet 7 uses an intermediate CA by default and Icinga cannot handle
          its CA certificate, see [Icinga Issue](https://github.com/Icinga/icinga2/pull/8859).
- icinga2: Uses the icinga2 CLI to generate a Certificate Request and Key to obtain a signed
           Certificate from 'ca_host' using the icinga2 ticket mechanism.
           In case the 'ticket_salt' has been configured the ticket_id will be generated
           by the module in a custom function that imitates the icinga ticket generation.
           The 'ticket_id' parameter can be used to directly set an ticket_id.
- none: Does nothing and you either have to manage the files yourself as file resources
        or use the ssl_key, ssl_cert, ssl_cacert parameters.

Default value: `'icinga2'`

##### <a name="-icinga2--feature--api--ssl_key"></a>`ssl_key`

Data type: `Optional[String]`

The private key in a base64 encoded string to store in cert directory. This parameter
requires pki to be set to 'none'.

Default value: `undef`

##### <a name="-icinga2--feature--api--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The certificate in a base64 encoded string to store in cert directory This parameter
 requires pki to be set to 'none'.

Default value: `undef`

##### <a name="-icinga2--feature--api--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA root certificate in a base64 encoded string to store in cert directory. This parameter
requires pki to be set to 'none'.

Default value: `undef`

##### <a name="-icinga2--feature--api--ssl_crl"></a>`ssl_crl`

Data type: `Optional[Stdlib::Absolutepath]`

Optional location of the certificate revocation list.

Default value: `undef`

##### <a name="-icinga2--feature--api--accept_config"></a>`accept_config`

Data type: `Optional[Boolean]`

Accept zone configuration.

Default value: `undef`

##### <a name="-icinga2--feature--api--accept_commands"></a>`accept_commands`

Data type: `Optional[Boolean]`

Accept remote commands.

Default value: `undef`

##### <a name="-icinga2--feature--api--max_anonymous_clients"></a>`max_anonymous_clients`

Data type: `Optional[Integer[0]]`

Limit the number of anonymous client connections (not configured endpoints and signing requests).

Default value: `undef`

##### <a name="-icinga2--feature--api--ca_host"></a>`ca_host`

Data type: `Optional[Stdlib::Host]`

This host will be connected to request the certificate. Set this if you use the icinga2 pki.

Default value: `undef`

##### <a name="-icinga2--feature--api--ca_port"></a>`ca_port`

Data type: `Stdlib::Port::Unprivileged`

Port of the 'ca_host'.

Default value: `5665`

##### <a name="-icinga2--feature--api--fingerprint"></a>`fingerprint`

Data type: `Optional[Icinga2::Fingerprint]`

Fingerprint of the CA host certificate for validation. Requires pki is set to `icinga2`.
You can get the fingerprint via 'openssl x509 -noout -fingerprint -sha256 -inform pem -in [certificate-file.crt]'
on your CA host. (Icinga2 versions before 2.12.0 require '-sha1' as digest algorithm.)

Default value: `undef`

##### <a name="-icinga2--feature--api--ticket_salt"></a>`ticket_salt`

Data type: `Variant[String, Sensitive[String]]`

Salt to use for ticket generation. The salt is stored to api.conf if none or ca is chosen for pki.
Defaults to constant TicketSalt. Keep in mind this parameter is parsed so please use only alpha numric
characters as salt or a constant.

Default value: `'TicketSalt'`

##### <a name="-icinga2--feature--api--ticket_id"></a>`ticket_id`

Data type: `Optional[Variant[String, Sensitive[String]]]`

If a ticket_id is given it will be used instead of generating an ticket_id.
The ticket_id will be used only when requesting a certificate from the ca_host
in case the pki is set to 'icinga2'.

Default value: `undef`

##### <a name="-icinga2--feature--api--endpoints"></a>`endpoints`

Data type: `Hash[String, Hash]`

Hash to configure endpoint objects. `NodeName` is a icnga2 constant.

Default value: `{ 'NodeName' => {} }`

##### <a name="-icinga2--feature--api--zones"></a>`zones`

Data type: `Hash[String, Hash]`

Hash to configure zone objects. `ZoneName` and `NodeName` are icinga2 constants.

Default value: `{ 'ZoneName' => { endpoints => ['NodeName'] } }`

##### <a name="-icinga2--feature--api--ssl_protocolmin"></a>`ssl_protocolmin`

Data type: `Optional[Enum['TLSv1', 'TLSv1.1', 'TLSv1.2', 'TLSv1.3']]`

Minimal TLS version to require.

Default value: `undef`

##### <a name="-icinga2--feature--api--ssl_handshake_timeout"></a>`ssl_handshake_timeout`

Data type: `Optional[Icinga2::Interval]`

TLS Handshake timeout.

Default value: `undef`

##### <a name="-icinga2--feature--api--connect_timeout"></a>`connect_timeout`

Data type: `Optional[Icinga2::Interval]`

Timeout for establishing new connections.

Default value: `undef`

##### <a name="-icinga2--feature--api--ssl_cipher_list"></a>`ssl_cipher_list`

Data type: `Optional[String]`

List of allowed TLS ciphers, to finetune encryption.

Default value: `undef`

##### <a name="-icinga2--feature--api--bind_host"></a>`bind_host`

Data type: `Optional[Stdlib::Host]`

The IP address the api listener will be bound to.

Default value: `undef`

##### <a name="-icinga2--feature--api--bind_port"></a>`bind_port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

The port the api listener will be bound to.

Default value: `undef`

##### <a name="-icinga2--feature--api--access_control_allow_origin"></a>`access_control_allow_origin`

Data type: `Optional[Array[String]]`

Specifies an array of origin URLs that may access the API.

Default value: `undef`

##### <a name="-icinga2--feature--api--access_control_allow_credentials"></a>`access_control_allow_credentials`

Data type: `Optional[Boolean]`

Indicates whether or not the actual request can be made using credentials.

Default value: `undef`

##### <a name="-icinga2--feature--api--access_control_allow_headers"></a>`access_control_allow_headers`

Data type: `Optional[String]`

Used in response to a preflight request to indicate which HTTP headers can be used when making the actual request.

Default value: `undef`

##### <a name="-icinga2--feature--api--access_control_allow_methods"></a>`access_control_allow_methods`

Data type: `Optional[Array[Enum['GET', 'POST', 'PUT', 'DELETE']]]`

Used in response to a preflight request to indicate which HTTP methods can be used when making the actual request.

Default value: `undef`

##### <a name="-icinga2--feature--api--environment"></a>`environment`

Data type: `Optional[String]`

Used as suffix in TLS SNI extension name; default from constant ApiEnvironment, which is empty.

Default value: `undef`

### <a name="icinga2--feature--checker"></a>`icinga2::feature::checker`

Configures the Icinga 2 feature checker.

#### Parameters

The following parameters are available in the `icinga2::feature::checker` class:

* [`ensure`](#-icinga2--feature--checker--ensure)

##### <a name="-icinga2--feature--checker--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature checker, absent disabled it.

Default value: `present`

### <a name="icinga2--feature--command"></a>`icinga2::feature::command`

Configures the Icinga 2 feature command.

#### Parameters

The following parameters are available in the `icinga2::feature::command` class:

* [`ensure`](#-icinga2--feature--command--ensure)
* [`command_path`](#-icinga2--feature--command--command_path)

##### <a name="-icinga2--feature--command--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present to enable the feature command, absent to disabled it.

Default value: `present`

##### <a name="-icinga2--feature--command--command_path"></a>`command_path`

Data type: `Optional[Stdlib::Absolutepath]`

Absolute path to the command pipe.

Default value: `undef`

### <a name="icinga2--feature--compatlog"></a>`icinga2::feature::compatlog`

Configures the Icinga 2 feature compatlog.

#### Parameters

The following parameters are available in the `icinga2::feature::compatlog` class:

* [`ensure`](#-icinga2--feature--compatlog--ensure)
* [`log_dir`](#-icinga2--feature--compatlog--log_dir)
* [`rotation_method`](#-icinga2--feature--compatlog--rotation_method)

##### <a name="-icinga2--feature--compatlog--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature compatlog, absent disabled it.

Default value: `present`

##### <a name="-icinga2--feature--compatlog--log_dir"></a>`log_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Absolute path to the log directory.

Default value: `undef`

##### <a name="-icinga2--feature--compatlog--rotation_method"></a>`rotation_method`

Data type: `Optional[Enum['DAILY', 'HOURLY', 'MONTHLY', 'WEEKLY']]`

Sets how often should the log file be rotated.

Default value: `undef`

### <a name="icinga2--feature--debuglog"></a>`icinga2::feature::debuglog`

Configures the Icinga 2 feature mainlog.

#### Parameters

The following parameters are available in the `icinga2::feature::debuglog` class:

* [`ensure`](#-icinga2--feature--debuglog--ensure)
* [`path`](#-icinga2--feature--debuglog--path)

##### <a name="-icinga2--feature--debuglog--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature mainlog, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--debuglog--path"></a>`path`

Data type: `Stdlib::Absolutepath`

Absolute path to the log file.

Default value: `"${icinga2::globals::log_dir}/debug.log"`

### <a name="icinga2--feature--elasticsearch"></a>`icinga2::feature::elasticsearch`

Configures the Icinga 2 feature elasticsearch.

#### Examples

##### 

```puppet
class { 'icinga2::feature::elasticsearch':
  host     => "10.10.0.15",
  index    => "icinga2"
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::elasticsearch` class:

* [`ensure`](#-icinga2--feature--elasticsearch--ensure)
* [`host`](#-icinga2--feature--elasticsearch--host)
* [`port`](#-icinga2--feature--elasticsearch--port)
* [`index`](#-icinga2--feature--elasticsearch--index)
* [`username`](#-icinga2--feature--elasticsearch--username)
* [`password`](#-icinga2--feature--elasticsearch--password)
* [`enable_ssl`](#-icinga2--feature--elasticsearch--enable_ssl)
* [`ssl_noverify`](#-icinga2--feature--elasticsearch--ssl_noverify)
* [`ssl_key_path`](#-icinga2--feature--elasticsearch--ssl_key_path)
* [`ssl_cert_path`](#-icinga2--feature--elasticsearch--ssl_cert_path)
* [`ssl_cacert_path`](#-icinga2--feature--elasticsearch--ssl_cacert_path)
* [`ssl_key`](#-icinga2--feature--elasticsearch--ssl_key)
* [`ssl_cert`](#-icinga2--feature--elasticsearch--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--elasticsearch--ssl_cacert)
* [`enable_send_perfdata`](#-icinga2--feature--elasticsearch--enable_send_perfdata)
* [`flush_interval`](#-icinga2--feature--elasticsearch--flush_interval)
* [`flush_threshold`](#-icinga2--feature--elasticsearch--flush_threshold)
* [`enable_ha`](#-icinga2--feature--elasticsearch--enable_ha)

##### <a name="-icinga2--feature--elasticsearch--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature elasticsearch, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--elasticsearch--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

Elasticsearch host address.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

Elasticsearch HTTP port.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--index"></a>`index`

Data type: `Optional[String]`

Elasticsearch index name.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--username"></a>`username`

Data type: `Optional[String]`

Elasticsearch user name.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--password"></a>`password`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Elasticsearch user password. The password parameter isn't parsed anymore.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--enable_ssl"></a>`enable_ssl`

Data type: `Optional[Boolean]`

Either enable or disable SSL. Other SSL parameters are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_noverify"></a>`ssl_noverify`

Data type: `Optional[Boolean]`

Disable TLS peer verification. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_key_path"></a>`ssl_key_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client private key. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_cert_path"></a>`ssl_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_cacert_path"></a>`ssl_cacert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_key"></a>`ssl_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The client private key in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA root certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--enable_send_perfdata"></a>`enable_send_perfdata`

Data type: `Optional[Boolean]`

Whether to send check performance data metrics.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--flush_interval"></a>`flush_interval`

Data type: `Optional[Icinga2::Interval]`

How long to buffer data points before transferring to Elasticsearch.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--flush_threshold"></a>`flush_threshold`

Data type: `Optional[Integer]`

How many data points to buffer before forcing a transfer to Elasticsearch.

Default value: `undef`

##### <a name="-icinga2--feature--elasticsearch--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--gelf"></a>`icinga2::feature::gelf`

Configures the Icinga 2 feature gelf.

#### Parameters

The following parameters are available in the `icinga2::feature::gelf` class:

* [`ensure`](#-icinga2--feature--gelf--ensure)
* [`host`](#-icinga2--feature--gelf--host)
* [`port`](#-icinga2--feature--gelf--port)
* [`source`](#-icinga2--feature--gelf--source)
* [`enable_ssl`](#-icinga2--feature--gelf--enable_ssl)
* [`ssl_key_path`](#-icinga2--feature--gelf--ssl_key_path)
* [`ssl_cert_path`](#-icinga2--feature--gelf--ssl_cert_path)
* [`ssl_cacert_path`](#-icinga2--feature--gelf--ssl_cacert_path)
* [`ssl_key`](#-icinga2--feature--gelf--ssl_key)
* [`ssl_cert`](#-icinga2--feature--gelf--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--gelf--ssl_cacert)
* [`ssl_noverify`](#-icinga2--feature--gelf--ssl_noverify)
* [`enable_send_perfdata`](#-icinga2--feature--gelf--enable_send_perfdata)
* [`enable_ha`](#-icinga2--feature--gelf--enable_ha)

##### <a name="-icinga2--feature--gelf--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature gelf, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--gelf--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

GELF receiver host address.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

GELF receiver port.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--source"></a>`source`

Data type: `Optional[String]`

Source name for this instance.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--enable_ssl"></a>`enable_ssl`

Data type: `Boolean`

Either enable or disable SSL/TLS. Other SSL parameters are only affected if this is set to 'true'.

Default value: `false`

##### <a name="-icinga2--feature--gelf--ssl_key_path"></a>`ssl_key_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--ssl_cert_path"></a>`ssl_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--ssl_cacert_path"></a>`ssl_cacert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--ssl_key"></a>`ssl_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The client private key in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--ssl_noverify"></a>`ssl_noverify`

Data type: `Optional[Boolean]`

Disable TLS peer verification. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--enable_send_perfdata"></a>`enable_send_perfdata`

Data type: `Optional[Boolean]`

Enable performance data for 'CHECK RESULT' events.

Default value: `undef`

##### <a name="-icinga2--feature--gelf--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--graphite"></a>`icinga2::feature::graphite`

Configures the Icinga 2 feature graphite.

#### Examples

##### 

```puppet
class { 'icinga2::feature::graphite':
  host                   => '10.10.0.15',
  port                   => 2003,
  enable_send_thresholds => true,
  enable_send_metadata   => true,
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::graphite` class:

* [`ensure`](#-icinga2--feature--graphite--ensure)
* [`host`](#-icinga2--feature--graphite--host)
* [`port`](#-icinga2--feature--graphite--port)
* [`host_name_template`](#-icinga2--feature--graphite--host_name_template)
* [`service_name_template`](#-icinga2--feature--graphite--service_name_template)
* [`enable_send_thresholds`](#-icinga2--feature--graphite--enable_send_thresholds)
* [`enable_send_metadata`](#-icinga2--feature--graphite--enable_send_metadata)
* [`enable_ha`](#-icinga2--feature--graphite--enable_ha)

##### <a name="-icinga2--feature--graphite--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature graphite, absent disabled it.

Default value: `present`

##### <a name="-icinga2--feature--graphite--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

Graphite Carbon host address.

Default value: `undef`

##### <a name="-icinga2--feature--graphite--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

Graphite Carbon port.

Default value: `undef`

##### <a name="-icinga2--feature--graphite--host_name_template"></a>`host_name_template`

Data type: `Optional[String]`

Template for metric path of hosts.

Default value: `undef`

##### <a name="-icinga2--feature--graphite--service_name_template"></a>`service_name_template`

Data type: `Optional[String]`

Template for metric path of services.

Default value: `undef`

##### <a name="-icinga2--feature--graphite--enable_send_thresholds"></a>`enable_send_thresholds`

Data type: `Optional[Boolean]`



Default value: `undef`

##### <a name="-icinga2--feature--graphite--enable_send_metadata"></a>`enable_send_metadata`

Data type: `Optional[Boolean]`



Default value: `undef`

##### <a name="-icinga2--feature--graphite--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--icingadb"></a>`icinga2::feature::icingadb`

Configures the Icinga 2 feature icingadb.

#### Parameters

The following parameters are available in the `icinga2::feature::icingadb` class:

* [`ensure`](#-icinga2--feature--icingadb--ensure)
* [`host`](#-icinga2--feature--icingadb--host)
* [`port`](#-icinga2--feature--icingadb--port)
* [`socket_path`](#-icinga2--feature--icingadb--socket_path)
* [`connect_timeout`](#-icinga2--feature--icingadb--connect_timeout)
* [`password`](#-icinga2--feature--icingadb--password)
* [`env_id`](#-icinga2--feature--icingadb--env_id)
* [`enable_tls`](#-icinga2--feature--icingadb--enable_tls)
* [`tls_key_file`](#-icinga2--feature--icingadb--tls_key_file)
* [`tls_cert_file`](#-icinga2--feature--icingadb--tls_cert_file)
* [`tls_cacert_file`](#-icinga2--feature--icingadb--tls_cacert_file)
* [`tls_crl_file`](#-icinga2--feature--icingadb--tls_crl_file)
* [`tls_key`](#-icinga2--feature--icingadb--tls_key)
* [`tls_cert`](#-icinga2--feature--icingadb--tls_cert)
* [`tls_cacert`](#-icinga2--feature--icingadb--tls_cacert)
* [`tls_capath`](#-icinga2--feature--icingadb--tls_capath)
* [`tls_cipher`](#-icinga2--feature--icingadb--tls_cipher)
* [`tls_protocolmin`](#-icinga2--feature--icingadb--tls_protocolmin)
* [`tls_noverify`](#-icinga2--feature--icingadb--tls_noverify)

##### <a name="-icinga2--feature--icingadb--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present, enables the feature icingadb, absent disabled it.

Default value: `present`

##### <a name="-icinga2--feature--icingadb--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

IcingaDB Redis host address.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

IcingaDB Redis port.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--socket_path"></a>`socket_path`

Data type: `Optional[Stdlib::Absolutepath]`

IcingaDB Redis unix sockt. Can be used instead of host and port attributes.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--connect_timeout"></a>`connect_timeout`

Data type: `Optional[Icinga2::Interval]`

Timeout for establishing new connections.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--password"></a>`password`

Data type: `Optional[Variant[String, Sensitive[String]]]`

IcingaDB Redis password. The password parameter isn't parsed anymore.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--env_id"></a>`env_id`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The ID is used in all Icinga DB components to separate data from multiple
different environments and is written to the file `/var/lib/icinga2/icingadb.env`
by Icinga 2. Icinga 2 generates a unique environment ID from its CA certificate
when it is first started with the Icinga DB feature enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--enable_tls"></a>`enable_tls`

Data type: `Boolean`

Either enable or disable SSL/TLS. Other SSL parameters are only affected if this is set to 'true'.

Default value: `false`

##### <a name="-icinga2--feature--icingadb--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_crl_file"></a>`tls_crl_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the Certicicate Revocation List. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_key"></a>`tls_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The private key in a PEM formated string to store spicified in tls_key_file.
Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_cert"></a>`tls_cert`

Data type: `Optional[String]`

The certificate in a PEM format string to store spicified in tls_cert_file.
Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String]`

The CA root certificate in a PEM formated string to store spicified in tls_cacert_file.
Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_capath"></a>`tls_capath`

Data type: `Optional[String]`

Path to all trusted CA certificates. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String]`

List of allowed ciphers. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_protocolmin"></a>`tls_protocolmin`

Data type: `Optional[String]`

Minimum TLS protocol version like `TLSv1.2`. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--icingadb--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Whether not to verify the peer.

Default value: `undef`

### <a name="icinga2--feature--idomysql"></a>`icinga2::feature::idomysql`

Installs and configures the Icinga 2 feature ido-mysql.

#### Examples

##### The ido-mysql featue requires an existing database and a user with permissions. This example uses the [puppetlabs/mysql](https://forge.puppet.com/puppetlabs/mysql) module.

```puppet
include mysql::server

mysql::db { 'icinga2':
  user     => 'icinga2',
  password => 'supersecret',
  host     => 'localhost',
  grant    => ['SELECT', 'INSERT', 'UPDATE', 'DELETE', 'DROP', 'CREATE VIEW', 'CREATE', 'INDEX', 'EXECUTE', 'ALTER'],
}

class{ 'icinga2::feature::idomysql':
  user          => "icinga2",
  password      => "supersecret",
  database      => "icinga2",
  import_schema => true,
  require       => Mysql::Db['icinga2']
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::idomysql` class:

* [`ensure`](#-icinga2--feature--idomysql--ensure)
* [`host`](#-icinga2--feature--idomysql--host)
* [`port`](#-icinga2--feature--idomysql--port)
* [`socket_path`](#-icinga2--feature--idomysql--socket_path)
* [`user`](#-icinga2--feature--idomysql--user)
* [`password`](#-icinga2--feature--idomysql--password)
* [`database`](#-icinga2--feature--idomysql--database)
* [`enable_ssl`](#-icinga2--feature--idomysql--enable_ssl)
* [`ssl_key_path`](#-icinga2--feature--idomysql--ssl_key_path)
* [`ssl_cert_path`](#-icinga2--feature--idomysql--ssl_cert_path)
* [`ssl_cacert_path`](#-icinga2--feature--idomysql--ssl_cacert_path)
* [`ssl_key`](#-icinga2--feature--idomysql--ssl_key)
* [`ssl_cert`](#-icinga2--feature--idomysql--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--idomysql--ssl_cacert)
* [`ssl_capath`](#-icinga2--feature--idomysql--ssl_capath)
* [`ssl_cipher`](#-icinga2--feature--idomysql--ssl_cipher)
* [`table_prefix`](#-icinga2--feature--idomysql--table_prefix)
* [`instance_name`](#-icinga2--feature--idomysql--instance_name)
* [`instance_description`](#-icinga2--feature--idomysql--instance_description)
* [`enable_ha`](#-icinga2--feature--idomysql--enable_ha)
* [`failover_timeout`](#-icinga2--feature--idomysql--failover_timeout)
* [`cleanup`](#-icinga2--feature--idomysql--cleanup)
* [`categories`](#-icinga2--feature--idomysql--categories)
* [`import_schema`](#-icinga2--feature--idomysql--import_schema)

##### <a name="-icinga2--feature--idomysql--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature ido-mysql, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--idomysql--host"></a>`host`

Data type: `Stdlib::Host`

MySQL database host address.

Default value: `'localhost'`

##### <a name="-icinga2--feature--idomysql--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

MySQL database port.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--socket_path"></a>`socket_path`

Data type: `Optional[Stdlib::Absolutepath]`

MySQL socket path.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--user"></a>`user`

Data type: `String`

MySQL database user with read/write permission to the icinga database.

Default value: `'icinga'`

##### <a name="-icinga2--feature--idomysql--password"></a>`password`

Data type: `Variant[String, Sensitive[String]]`

MySQL database user's password. The password parameter isn't parsed anymore.

##### <a name="-icinga2--feature--idomysql--database"></a>`database`

Data type: `String`

MySQL database name.

Default value: `'icinga'`

##### <a name="-icinga2--feature--idomysql--enable_ssl"></a>`enable_ssl`

Data type: `Boolean`

Either enable or disable SSL/TLS. Other SSL parameters are only affected if this is set to 'true'.

Default value: `false`

##### <a name="-icinga2--feature--idomysql--ssl_key_path"></a>`ssl_key_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client private key. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_cert_path"></a>`ssl_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_cacert_path"></a>`ssl_cacert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_key"></a>`ssl_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The client private key in PEM Format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA root certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_capath"></a>`ssl_capath`

Data type: `Optional[Stdlib::Absolutepath]`

MySQL SSL trusted SSL CA certificates in PEM format directory path. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--ssl_cipher"></a>`ssl_cipher`

Data type: `Optional[String]`

MySQL SSL list of allowed ciphers. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--table_prefix"></a>`table_prefix`

Data type: `Optional[String]`

MySQL database table prefix.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--instance_name"></a>`instance_name`

Data type: `Optional[String]`

Unique identifier for the local Icinga 2 instance.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--instance_description"></a>`instance_description`

Data type: `Optional[String]`

Description for the Icinga 2 instance.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--failover_timeout"></a>`failover_timeout`

Data type: `Optional[Icinga2::Interval]`

Set the failover timeout in a HA cluster. Must not be lower than 60s.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--cleanup"></a>`cleanup`

Data type: `Optional[Icinga2::IdoCleanup]`

Hash with items for historical table cleanup.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--categories"></a>`categories`

Data type: `Optional[Array]`

Array of information types that should be written to the database.

Default value: `undef`

##### <a name="-icinga2--feature--idomysql--import_schema"></a>`import_schema`

Data type: `Variant[Boolean, Enum['mariadb', 'mysql']]`

Whether to import the MySQL schema or not. New options `mariadb` and `mysql`,
both means true. With mariadb its cli options are used for the import,
whereas with mysql its different options.

Default value: `false`

### <a name="icinga2--feature--idopgsql"></a>`icinga2::feature::idopgsql`

Installs and configures the Icinga 2 feature ido-pgsql.

#### Examples

##### The ido-pgsql featue requires an existing database and a user with permissions. This example uses the [puppetlab/postgresql](https://forge.puppet.com/puppetlabs/postgresql) module.

```puppet
include icinga2
include postgresql::server

postgresql::server::db { 'icinga2':
  user     => 'icinga2',
  password => postgresql::postgresql_password('icinga2', 'supersecret'),
}

class{ 'icinga2::feature::idopgsql':
  user          => 'icinga2',
  password      => 'supersecret',
  database      => 'icinga2',
  import_schema => true,
  require       => Postgresql::Server::Db['icinga2']
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::idopgsql` class:

* [`ensure`](#-icinga2--feature--idopgsql--ensure)
* [`host`](#-icinga2--feature--idopgsql--host)
* [`port`](#-icinga2--feature--idopgsql--port)
* [`user`](#-icinga2--feature--idopgsql--user)
* [`password`](#-icinga2--feature--idopgsql--password)
* [`database`](#-icinga2--feature--idopgsql--database)
* [`ssl_mode`](#-icinga2--feature--idopgsql--ssl_mode)
* [`ssl_key_path`](#-icinga2--feature--idopgsql--ssl_key_path)
* [`ssl_cert_path`](#-icinga2--feature--idopgsql--ssl_cert_path)
* [`ssl_cacert_path`](#-icinga2--feature--idopgsql--ssl_cacert_path)
* [`ssl_key`](#-icinga2--feature--idopgsql--ssl_key)
* [`ssl_cert`](#-icinga2--feature--idopgsql--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--idopgsql--ssl_cacert)
* [`table_prefix`](#-icinga2--feature--idopgsql--table_prefix)
* [`instance_name`](#-icinga2--feature--idopgsql--instance_name)
* [`instance_description`](#-icinga2--feature--idopgsql--instance_description)
* [`enable_ha`](#-icinga2--feature--idopgsql--enable_ha)
* [`failover_timeout`](#-icinga2--feature--idopgsql--failover_timeout)
* [`cleanup`](#-icinga2--feature--idopgsql--cleanup)
* [`categories`](#-icinga2--feature--idopgsql--categories)
* [`import_schema`](#-icinga2--feature--idopgsql--import_schema)

##### <a name="-icinga2--feature--idopgsql--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature ido-pgsql, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--idopgsql--host"></a>`host`

Data type: `Stdlib::Host`

PostgreSQL database host address.

Default value: `'localhost'`

##### <a name="-icinga2--feature--idopgsql--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

PostgreSQL database port.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--user"></a>`user`

Data type: `String`

PostgreSQL database user with read/write permission to the icinga database.

Default value: `'icinga'`

##### <a name="-icinga2--feature--idopgsql--password"></a>`password`

Data type: `Variant[String, Sensitive[String]]`

PostgreSQL database user's password. The password parameter isn't parsed anymore.

##### <a name="-icinga2--feature--idopgsql--database"></a>`database`

Data type: `String`

PostgreSQL database name.

Default value: `'icinga'`

##### <a name="-icinga2--feature--idopgsql--ssl_mode"></a>`ssl_mode`

Data type: `Optional[Enum['verify-full', 'verify-ca']]`

Enable SSL connection mode.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--ssl_key_path"></a>`ssl_key_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key. Only valid if ssl_mode is set unequal to `disabled`.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--ssl_cert_path"></a>`ssl_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate. Only valid if ssl_mode is set unequal to `disabled`.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--ssl_cacert_path"></a>`ssl_cacert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if ssl_mode is set unequal to `disabled`.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--ssl_key"></a>`ssl_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The client private key in PEM format. Only valid if ssl_mode is set unequal to `disabled`.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if ssl_mode is set unequal to `disabled`.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA root certificate in PEM format. Only valid if ssl_mode is set unequal to `disabled`.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--table_prefix"></a>`table_prefix`

Data type: `Optional[String]`

PostgreSQL database table prefix.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--instance_name"></a>`instance_name`

Data type: `Optional[String]`

Unique identifier for the local Icinga 2 instance.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--instance_description"></a>`instance_description`

Data type: `Optional[String]`

Description of the Icinga 2 instance.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--failover_timeout"></a>`failover_timeout`

Data type: `Optional[Icinga2::Interval]`

Set the failover timeout in a HA cluster. Must not be lower than 60s.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--cleanup"></a>`cleanup`

Data type: `Optional[Icinga2::IdoCleanup]`

Hash with items for historical table cleanup.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--categories"></a>`categories`

Data type: `Optional[Array]`

Array of information types that should be written to the database.

Default value: `undef`

##### <a name="-icinga2--feature--idopgsql--import_schema"></a>`import_schema`

Data type: `Boolean`

Whether to import the PostgreSQL schema or not.

Default value: `false`

### <a name="icinga2--feature--influxdb"></a>`icinga2::feature::influxdb`

Configures the Icinga 2 feature influxdb.

#### Examples

##### 

```puppet
class { 'icinga2::feature::influxdb':
  host     => "10.10.0.15",
  username => "icinga2",
  password => "supersecret",
  database => "icinga2"
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::influxdb` class:

* [`ensure`](#-icinga2--feature--influxdb--ensure)
* [`host`](#-icinga2--feature--influxdb--host)
* [`port`](#-icinga2--feature--influxdb--port)
* [`database`](#-icinga2--feature--influxdb--database)
* [`username`](#-icinga2--feature--influxdb--username)
* [`password`](#-icinga2--feature--influxdb--password)
* [`basic_auth`](#-icinga2--feature--influxdb--basic_auth)
* [`enable_ssl`](#-icinga2--feature--influxdb--enable_ssl)
* [`ssl_noverify`](#-icinga2--feature--influxdb--ssl_noverify)
* [`ssl_key_path`](#-icinga2--feature--influxdb--ssl_key_path)
* [`ssl_cert_path`](#-icinga2--feature--influxdb--ssl_cert_path)
* [`ssl_cacert_path`](#-icinga2--feature--influxdb--ssl_cacert_path)
* [`ssl_key`](#-icinga2--feature--influxdb--ssl_key)
* [`ssl_cert`](#-icinga2--feature--influxdb--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--influxdb--ssl_cacert)
* [`host_measurement`](#-icinga2--feature--influxdb--host_measurement)
* [`host_tags`](#-icinga2--feature--influxdb--host_tags)
* [`service_measurement`](#-icinga2--feature--influxdb--service_measurement)
* [`service_tags`](#-icinga2--feature--influxdb--service_tags)
* [`enable_send_thresholds`](#-icinga2--feature--influxdb--enable_send_thresholds)
* [`enable_send_metadata`](#-icinga2--feature--influxdb--enable_send_metadata)
* [`flush_interval`](#-icinga2--feature--influxdb--flush_interval)
* [`flush_threshold`](#-icinga2--feature--influxdb--flush_threshold)
* [`enable_ha`](#-icinga2--feature--influxdb--enable_ha)

##### <a name="-icinga2--feature--influxdb--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature influxdb, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--influxdb--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

InfluxDB host address.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--port"></a>`port`

Data type: `Optional[Stdlib::Port]`

InfluxDB HTTP port.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--database"></a>`database`

Data type: `Optional[String]`

InfluxDB database name.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--username"></a>`username`

Data type: `Optional[String]`

InfluxDB user name.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--password"></a>`password`

Data type: `Optional[Variant[String, Sensitive[String]]]`

InfluxDB user password. The password parameter isn't parsed anymore.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--basic_auth"></a>`basic_auth`

Data type: `Optional[Icinga2::BasicAuth]`

Username and password for HTTP basic authentication.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--enable_ssl"></a>`enable_ssl`

Data type: `Optional[Boolean]`

Either enable or disable SSL. Other SSL parameters are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_noverify"></a>`ssl_noverify`

Data type: `Optional[Boolean]`

Disable TLS peer verification. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_key_path"></a>`ssl_key_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client private key. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_cert_path"></a>`ssl_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_cacert_path"></a>`ssl_cacert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_key"></a>`ssl_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The client private key in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA root certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--host_measurement"></a>`host_measurement`

Data type: `String`

The value of this is used for the measurement setting in host_template.

Default value: `'$host.check_command$'`

##### <a name="-icinga2--feature--influxdb--host_tags"></a>`host_tags`

Data type: `Hash`

Tags defined in this hash will be set in the host_template.

Default value: `{ hostname => '$host.name$' }`

##### <a name="-icinga2--feature--influxdb--service_measurement"></a>`service_measurement`

Data type: `String`

The value of this is used for the measurement setting in host_template.

Default value: `'$service.check_command$'`

##### <a name="-icinga2--feature--influxdb--service_tags"></a>`service_tags`

Data type: `Hash`

Tags defined in this hash will be set in the service_template.

Default value: `{ hostname => '$host.name$', service => '$service.name$' }`

##### <a name="-icinga2--feature--influxdb--enable_send_thresholds"></a>`enable_send_thresholds`

Data type: `Optional[Boolean]`

Whether to send warn, crit, min & max tagged data.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--enable_send_metadata"></a>`enable_send_metadata`

Data type: `Optional[Boolean]`

Whether to send check metadata e.g. states, execution time, latency etc.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--flush_interval"></a>`flush_interval`

Data type: `Optional[Icinga2::Interval]`

How long to buffer data points before transfering to InfluxDB.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--flush_threshold"></a>`flush_threshold`

Data type: `Optional[Integer[1]]`

How many data points to buffer before forcing a transfer to InfluxDB.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--influxdb2"></a>`icinga2::feature::influxdb2`

Configures the Icinga 2 feature influxdb2.

#### Examples

##### 

```puppet
class { 'icinga2::feature::influxdb2':
  host         => "10.10.0.15",
  organization => "ICINGA",
  bucket       => "icinga2",
  auth_token   => "supersecret",
}
```

#### Parameters

The following parameters are available in the `icinga2::feature::influxdb2` class:

* [`ensure`](#-icinga2--feature--influxdb2--ensure)
* [`host`](#-icinga2--feature--influxdb2--host)
* [`port`](#-icinga2--feature--influxdb2--port)
* [`organization`](#-icinga2--feature--influxdb2--organization)
* [`bucket`](#-icinga2--feature--influxdb2--bucket)
* [`auth_token`](#-icinga2--feature--influxdb2--auth_token)
* [`enable_ssl`](#-icinga2--feature--influxdb2--enable_ssl)
* [`ssl_noverify`](#-icinga2--feature--influxdb2--ssl_noverify)
* [`ssl_key_path`](#-icinga2--feature--influxdb2--ssl_key_path)
* [`ssl_cert_path`](#-icinga2--feature--influxdb2--ssl_cert_path)
* [`ssl_cacert_path`](#-icinga2--feature--influxdb2--ssl_cacert_path)
* [`ssl_key`](#-icinga2--feature--influxdb2--ssl_key)
* [`ssl_cert`](#-icinga2--feature--influxdb2--ssl_cert)
* [`ssl_cacert`](#-icinga2--feature--influxdb2--ssl_cacert)
* [`host_measurement`](#-icinga2--feature--influxdb2--host_measurement)
* [`host_tags`](#-icinga2--feature--influxdb2--host_tags)
* [`service_measurement`](#-icinga2--feature--influxdb2--service_measurement)
* [`service_tags`](#-icinga2--feature--influxdb2--service_tags)
* [`enable_send_thresholds`](#-icinga2--feature--influxdb2--enable_send_thresholds)
* [`enable_send_metadata`](#-icinga2--feature--influxdb2--enable_send_metadata)
* [`flush_interval`](#-icinga2--feature--influxdb2--flush_interval)
* [`flush_threshold`](#-icinga2--feature--influxdb2--flush_threshold)
* [`enable_ha`](#-icinga2--feature--influxdb2--enable_ha)

##### <a name="-icinga2--feature--influxdb2--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature influxdb, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--influxdb2--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

InfluxDB host address.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--port"></a>`port`

Data type: `Optional[Stdlib::Port]`

InfluxDB HTTP port.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--organization"></a>`organization`

Data type: `String`

InfluxDB organization name.

##### <a name="-icinga2--feature--influxdb2--bucket"></a>`bucket`

Data type: `String`

InfluxDB bucket name.

##### <a name="-icinga2--feature--influxdb2--auth_token"></a>`auth_token`

Data type: `Variant[String, Sensitive[String]]`

InfluxDB authentication token.

##### <a name="-icinga2--feature--influxdb2--enable_ssl"></a>`enable_ssl`

Data type: `Optional[Boolean]`

Either enable or disable SSL. Other SSL parameters are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_noverify"></a>`ssl_noverify`

Data type: `Optional[Boolean]`

Disable TLS peer verification. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_key_path"></a>`ssl_key_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client private key. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_cert_path"></a>`ssl_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_cacert_path"></a>`ssl_cacert_path`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_key"></a>`ssl_key`

Data type: `Optional[Variant[String, Sensitive[String]]]`

The client private key in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_cert"></a>`ssl_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--ssl_cacert"></a>`ssl_cacert`

Data type: `Optional[String]`

The CA root certificate in PEM format. Only valid if ssl is enabled.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--host_measurement"></a>`host_measurement`

Data type: `String`

The value of this is used for the measurement setting in host_template.

Default value: `'$host.check_command$'`

##### <a name="-icinga2--feature--influxdb2--host_tags"></a>`host_tags`

Data type: `Hash`

Tags defined in this hash will be set in the host_template.

Default value: `{ hostname => '$host.name$' }`

##### <a name="-icinga2--feature--influxdb2--service_measurement"></a>`service_measurement`

Data type: `String`

The value of this is used for the measurement setting in host_template.

Default value: `'$service.check_command$'`

##### <a name="-icinga2--feature--influxdb2--service_tags"></a>`service_tags`

Data type: `Hash`

Tags defined in this hash will be set in the service_template.

Default value: `{ hostname => '$host.name$', service => '$service.name$' }`

##### <a name="-icinga2--feature--influxdb2--enable_send_thresholds"></a>`enable_send_thresholds`

Data type: `Optional[Boolean]`

Whether to send warn, crit, min & max tagged data.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--enable_send_metadata"></a>`enable_send_metadata`

Data type: `Optional[Boolean]`

Whether to send check metadata e.g. states, execution time, latency etc.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--flush_interval"></a>`flush_interval`

Data type: `Optional[Icinga2::Interval]`

How long to buffer data points before transfering to InfluxDB.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--flush_threshold"></a>`flush_threshold`

Data type: `Optional[Integer[1]]`

How many data points to buffer before forcing a transfer to InfluxDB.

Default value: `undef`

##### <a name="-icinga2--feature--influxdb2--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--livestatus"></a>`icinga2::feature::livestatus`

Configures the Icinga 2 feature livestatus.

#### Parameters

The following parameters are available in the `icinga2::feature::livestatus` class:

* [`ensure`](#-icinga2--feature--livestatus--ensure)
* [`socket_type`](#-icinga2--feature--livestatus--socket_type)
* [`bind_host`](#-icinga2--feature--livestatus--bind_host)
* [`bind_port`](#-icinga2--feature--livestatus--bind_port)
* [`socket_path`](#-icinga2--feature--livestatus--socket_path)
* [`compat_log_path`](#-icinga2--feature--livestatus--compat_log_path)

##### <a name="-icinga2--feature--livestatus--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature livestatus, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--livestatus--socket_type"></a>`socket_type`

Data type: `Optional[Enum['tcp', 'unix']]`

Specifies the socket type. Can be either 'tcp' or 'unix'.

Default value: `undef`

##### <a name="-icinga2--feature--livestatus--bind_host"></a>`bind_host`

Data type: `Optional[Stdlib::Host]`

IP address to listen for connections. Only valid when socket_type is 'tcp'.

Default value: `undef`

##### <a name="-icinga2--feature--livestatus--bind_port"></a>`bind_port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

Port to listen for connections. Only valid when socket_type is 'tcp'.

Default value: `undef`

##### <a name="-icinga2--feature--livestatus--socket_path"></a>`socket_path`

Data type: `Optional[Stdlib::Absolutepath]`

Specifies the path to the UNIX socket file. Only valid when socket_type is 'unix'.

Default value: `undef`

##### <a name="-icinga2--feature--livestatus--compat_log_path"></a>`compat_log_path`

Data type: `Optional[Stdlib::Absolutepath]`

Required for historical table queries. Requires CompatLogger feature to be enabled.

Default value: `undef`

### <a name="icinga2--feature--mainlog"></a>`icinga2::feature::mainlog`

Configures the Icinga 2 feature mainlog.

#### Parameters

The following parameters are available in the `icinga2::feature::mainlog` class:

* [`ensure`](#-icinga2--feature--mainlog--ensure)
* [`severity`](#-icinga2--feature--mainlog--severity)
* [`path`](#-icinga2--feature--mainlog--path)

##### <a name="-icinga2--feature--mainlog--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to 'present' enables the feature mainlog, 'absent' disabled it.

Default value: `present`

##### <a name="-icinga2--feature--mainlog--severity"></a>`severity`

Data type: `Icinga2::LogSeverity`

You can set the log severity to 'information', 'notice', 'warning' or 'debug'.

Default value: `'information'`

##### <a name="-icinga2--feature--mainlog--path"></a>`path`

Data type: `Stdlib::Absolutepath`

Absolute path to the log file.

Default value: `"${icinga2::globals::log_dir}/icinga2.log"`

### <a name="icinga2--feature--notification"></a>`icinga2::feature::notification`

Configures the Icinga 2 feature notification.

#### Parameters

The following parameters are available in the `icinga2::feature::notification` class:

* [`ensure`](#-icinga2--feature--notification--ensure)
* [`enable_ha`](#-icinga2--feature--notification--enable_ha)

##### <a name="-icinga2--feature--notification--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature notification, absent disabled it.

Default value: `present`

##### <a name="-icinga2--feature--notification--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Notifications are load-balanced amongst all nodes in a zone.

Default value: `undef`

### <a name="icinga2--feature--opentsdb"></a>`icinga2::feature::opentsdb`

Configures the Icinga 2 feature opentsdb.

#### Parameters

The following parameters are available in the `icinga2::feature::opentsdb` class:

* [`ensure`](#-icinga2--feature--opentsdb--ensure)
* [`host`](#-icinga2--feature--opentsdb--host)
* [`port`](#-icinga2--feature--opentsdb--port)
* [`enable_ha`](#-icinga2--feature--opentsdb--enable_ha)

##### <a name="-icinga2--feature--opentsdb--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature opentsdb, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--opentsdb--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

OpenTSDB host address.

Default value: `undef`

##### <a name="-icinga2--feature--opentsdb--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

OpenTSDB port.

Default value: `undef`

##### <a name="-icinga2--feature--opentsdb--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--perfdata"></a>`icinga2::feature::perfdata`

Configures the Icinga 2 feature perfdata.

#### Parameters

The following parameters are available in the `icinga2::feature::perfdata` class:

* [`ensure`](#-icinga2--feature--perfdata--ensure)
* [`host_perfdata_path`](#-icinga2--feature--perfdata--host_perfdata_path)
* [`service_perfdata_path`](#-icinga2--feature--perfdata--service_perfdata_path)
* [`host_temp_path`](#-icinga2--feature--perfdata--host_temp_path)
* [`service_temp_path`](#-icinga2--feature--perfdata--service_temp_path)
* [`host_format_template`](#-icinga2--feature--perfdata--host_format_template)
* [`service_format_template`](#-icinga2--feature--perfdata--service_format_template)
* [`rotation_interval`](#-icinga2--feature--perfdata--rotation_interval)
* [`enable_ha`](#-icinga2--feature--perfdata--enable_ha)

##### <a name="-icinga2--feature--perfdata--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature perfdata, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--perfdata--host_perfdata_path"></a>`host_perfdata_path`

Data type: `Optional[Stdlib::Absolutepath]`

Absolute path to the perfdata file for hosts.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--service_perfdata_path"></a>`service_perfdata_path`

Data type: `Optional[Stdlib::Absolutepath]`

Absolute path to the perfdata file for services.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--host_temp_path"></a>`host_temp_path`

Data type: `Optional[Stdlib::Absolutepath]`

Path to the temporary host file.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--service_temp_path"></a>`service_temp_path`

Data type: `Optional[Stdlib::Absolutepath]`

Path to the temporary service file.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--host_format_template"></a>`host_format_template`

Data type: `Optional[String]`

Host Format template for the performance data file.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--service_format_template"></a>`service_format_template`

Data type: `Optional[String]`

Service Format template for the performance data file.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--rotation_interval"></a>`rotation_interval`

Data type: `Optional[Icinga2::Interval]`

Rotation interval for the files specified in {host,service}_perfdata_path. Can be written in minutes or seconds,
i.e. 1m or 15s.

Default value: `undef`

##### <a name="-icinga2--feature--perfdata--enable_ha"></a>`enable_ha`

Data type: `Optional[Boolean]`

Enable the high availability functionality. Only valid in a cluster setup.

Default value: `undef`

### <a name="icinga2--feature--statusdata"></a>`icinga2::feature::statusdata`

Configures the Icinga 2 feature statusdata.

#### Parameters

The following parameters are available in the `icinga2::feature::statusdata` class:

* [`ensure`](#-icinga2--feature--statusdata--ensure)
* [`status_path`](#-icinga2--feature--statusdata--status_path)
* [`objects_path`](#-icinga2--feature--statusdata--objects_path)
* [`update_interval`](#-icinga2--feature--statusdata--update_interval)

##### <a name="-icinga2--feature--statusdata--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature statusdata, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--statusdata--status_path"></a>`status_path`

Data type: `Optional[Stdlib::Absolutepath]`

Absolute path to the status.dat file.

Default value: `undef`

##### <a name="-icinga2--feature--statusdata--objects_path"></a>`objects_path`

Data type: `Optional[Stdlib::Absolutepath]`

Absolute path to the object.cache file.

Default value: `undef`

##### <a name="-icinga2--feature--statusdata--update_interval"></a>`update_interval`

Data type: `Optional[Icinga2::Interval]`

Interval in seconds to update both status files. You can also specify
it in minutes with the letter m or in seconds with s.

Default value: `undef`

### <a name="icinga2--feature--syslog"></a>`icinga2::feature::syslog`

Configures the Icinga 2 feature syslog.

#### Parameters

The following parameters are available in the `icinga2::feature::syslog` class:

* [`ensure`](#-icinga2--feature--syslog--ensure)
* [`severity`](#-icinga2--feature--syslog--severity)
* [`facility`](#-icinga2--feature--syslog--facility)

##### <a name="-icinga2--feature--syslog--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature syslog, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--syslog--severity"></a>`severity`

Data type: `Icinga2::LogSeverity`

You can choose the log severity between information, notice, warning or debug.

Default value: `'warning'`

##### <a name="-icinga2--feature--syslog--facility"></a>`facility`

Data type: `Optional[Icinga2::LogFacility]`

Defines the facility to use for syslog entries. This can be a facility constant
like FacilityDaemon.

Default value: `undef`

### <a name="icinga2--feature--windowseventlog"></a>`icinga2::feature::windowseventlog`

Configures the Icinga 2 feature windowseventlog.

#### Parameters

The following parameters are available in the `icinga2::feature::windowseventlog` class:

* [`ensure`](#-icinga2--feature--windowseventlog--ensure)
* [`severity`](#-icinga2--feature--windowseventlog--severity)

##### <a name="-icinga2--feature--windowseventlog--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the feature windowseventlog, absent disables it.

Default value: `present`

##### <a name="-icinga2--feature--windowseventlog--severity"></a>`severity`

Data type: `Icinga2::LogSeverity`

You can choose the log severity between information, notice, warning or debug.

Default value: `'warning'`

### <a name="icinga2--pki--ca"></a>`icinga2::pki::ca`

This class provides multiple ways to create the CA used by Icinga 2.

#### Examples

##### Let Icinga 2 generate a CA for you:

```puppet
include icinga2
include icinga2::pki::ca
```

##### Set the content of CA certificate and key:

```puppet
include icinga2

class { 'icinga2::pki::ca':
  ca_cert => '-----BEGIN CERTIFICATE----- ...',
  ca_key  => '-----BEGIN RSA PRIVATE KEY----- ...',
}
```

#### Parameters

The following parameters are available in the `icinga2::pki::ca` class:

* [`ca_cert`](#-icinga2--pki--ca--ca_cert)
* [`ca_key`](#-icinga2--pki--ca--ca_key)

##### <a name="-icinga2--pki--ca--ca_cert"></a>`ca_cert`

Data type: `Optional[String]`

Content of the CA certificate. If this is unset, a certificate will be generated with the
Icinga 2 CLI.

Default value: `undef`

##### <a name="-icinga2--pki--ca--ca_key"></a>`ca_key`

Data type: `Optional[String]`

Content of the CA key. If this is unset, a key will be generated with the Icinga 2 CLI.

Default value: `undef`

### <a name="icinga2--query_objects"></a>`icinga2::query_objects`

Class to query `icinga2::objects` from puppetdb.

#### Parameters

The following parameters are available in the `icinga2::query_objects` class:

* [`destination`](#-icinga2--query_objects--destination)
* [`environments`](#-icinga2--query_objects--environments)

##### <a name="-icinga2--query_objects--destination"></a>`destination`

Data type: `String`

Destination equal to what was set in parameter `export` for objects.

Default value: `$facts['networking']['fqdn']`

##### <a name="-icinga2--query_objects--environments"></a>`environments`

Data type: `Array[String]`

limits the response to objects of these environments if set, all environments if list is empty

Default value: `[$environment]`

## Defined types

### <a name="icinga2--config--fragment"></a>`icinga2::config::fragment`

Set a code fragment in a target configuration file. It's not possible to add a fragment to an object.

#### Examples

##### To create a custom configuration add content to a specified target at the position you set in the order parameter.

```puppet
include ::icinga2

icinga2::object::service { 'load':
  display_name  => 'Load',
  apply         => true,
  check_command => 'load',
  vars          => {
    load_wload1 => 'dynamic_threshold(backup, 20, 5)',
    load_cload1 => 'dynamic_threshold(backup, 40, 10)',
  },
  assign        => ['vars.os == Linux'],
  target        => '/etc/icinga2/example.d/services.conf',
  order         => 30,
}

icinga2::config::fragment { 'load-function':
  target  => '/etc/icinga2/example.d/services.conf',
  order   => 10,
  content => "globals.dynamic_threshold = function(timeperiod, ivalue, ovalue) {
  return function() use (timeperiod, ivalue, ovalue) {
    if (get_time_period(timeperiod).is_inside) {
      return ivalue
    } else {
      return ovalue
    }
  }
}\n",
}
```

#### Parameters

The following parameters are available in the `icinga2::config::fragment` defined type:

* [`content`](#-icinga2--config--fragment--content)
* [`target`](#-icinga2--config--fragment--target)
* [`code_name`](#-icinga2--config--fragment--code_name)
* [`order`](#-icinga2--config--fragment--order)

##### <a name="-icinga2--config--fragment--content"></a>`content`

Data type: `String`

Content to insert in file specified in target.

##### <a name="-icinga2--config--fragment--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this fragment. File will be declared the
first time.

##### <a name="-icinga2--config--fragment--code_name"></a>`code_name`

Data type: `String`

Namevar of the fragment.

Default value: `$title`

##### <a name="-icinga2--config--fragment--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted in alpha numeric order. Defaults to `00`.

Default value: `'00'`

### <a name="icinga2--object--apiuser"></a>`icinga2::object::apiuser`

Manage Icinga 2 ApiUser objects.

#### Examples

##### Create an user with full permissions:

```puppet
::icinga2::object::apiuser { 'director':
  ensure      => present,
  password    => 'Eih5Weefoo2oa8sh',
  permissions => [ '*' ],
  target      => '/etc/icinga2/conf.d/api-users.conf',
}
```

##### Create an user with restricted permissions for Icinga Web 2:

```puppet
::icinga2::object::apiuser { 'icingaweb2':
  ensure      => present,
  password    => '12e2ef553068b519',
  permissions => [ 'status/query', 'actions/*', 'objects/modify/*', 'objects/query/*' ],
  target      => '/etc/icinga2/conf.d/api-users.conf',
}
```

##### Create user who's only allowed to query hosts and services:

```puppet
::icinga2::object::apiuser { 'read':
  ensure      => present,
  password    => 'read',
  permissions => [
    {
      permission => 'objects/query/Host',
      filter     => '{{ regex("^Linux", host.vars.os) }}'
    },
    {
      permission => 'objects/query/Service',
      filter     => '{{ regex("^Linux", host.vars.os) }}'
    },
  ],
  target      => '/etc/icinga2/conf.d/api-users.conf',
}
```

#### Parameters

The following parameters are available in the `icinga2::object::apiuser` defined type:

* [`ensure`](#-icinga2--object--apiuser--ensure)
* [`apiuser_name`](#-icinga2--object--apiuser--apiuser_name)
* [`password`](#-icinga2--object--apiuser--password)
* [`client_cn`](#-icinga2--object--apiuser--client_cn)
* [`permissions`](#-icinga2--object--apiuser--permissions)
* [`target`](#-icinga2--object--apiuser--target)
* [`order`](#-icinga2--object--apiuser--order)
* [`export`](#-icinga2--object--apiuser--export)

##### <a name="-icinga2--object--apiuser--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--apiuser--apiuser_name"></a>`apiuser_name`

Data type: `String`

Set the name of the apiuser object.

Default value: `$title`

##### <a name="-icinga2--object--apiuser--password"></a>`password`

Data type: `Optional[Variant[String, Sensitive[String]]]`

Password string. The password parameter isn't parsed anymore.

Default value: `undef`

##### <a name="-icinga2--object--apiuser--client_cn"></a>`client_cn`

Data type: `Optional[String]`

Optional. Client Common Name (CN).

Default value: `undef`

##### <a name="-icinga2--object--apiuser--permissions"></a>`permissions`

Data type: `Optional[Array]`

Array of permissions. Either as string or dictionary with the keys permission
and filter. The latter must be specified as function.

Default value: `undef`

##### <a name="-icinga2--object--apiuser--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared at the
first time.

##### <a name="-icinga2--object--apiuser--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `30`

##### <a name="-icinga2--object--apiuser--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--checkcommand"></a>`icinga2::object::checkcommand`

Manage Icinga 2 Host objects.

#### Parameters

The following parameters are available in the `icinga2::object::checkcommand` defined type:

* [`ensure`](#-icinga2--object--checkcommand--ensure)
* [`checkcommand_name`](#-icinga2--object--checkcommand--checkcommand_name)
* [`import`](#-icinga2--object--checkcommand--import)
* [`command`](#-icinga2--object--checkcommand--command)
* [`env`](#-icinga2--object--checkcommand--env)
* [`vars`](#-icinga2--object--checkcommand--vars)
* [`timeout`](#-icinga2--object--checkcommand--timeout)
* [`arguments`](#-icinga2--object--checkcommand--arguments)
* [`target`](#-icinga2--object--checkcommand--target)
* [`template`](#-icinga2--object--checkcommand--template)
* [`order`](#-icinga2--object--checkcommand--order)
* [`export`](#-icinga2--object--checkcommand--export)

##### <a name="-icinga2--object--checkcommand--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--checkcommand--checkcommand_name"></a>`checkcommand_name`

Data type: `String`

Title of the CheckCommand object.

Default value: `$title`

##### <a name="-icinga2--object--checkcommand--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--checkcommand--command"></a>`command`

Data type: `Optional[Variant[Array, String]]`

The command. This can either be an array of individual command arguments.
Alternatively a string can be specified in which case the shell interpreter (usually /bin/sh) takes care of parsing the command.
When using the "arguments" attribute this must be an array. Can be specified as function for advanced implementations.

Default value: `undef`

##### <a name="-icinga2--object--checkcommand--env"></a>`env`

Data type: `Optional[Hash]`

A dictionary of macros which should be exported as environment variables prior to executing the command.

Default value: `undef`

##### <a name="-icinga2--object--checkcommand--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--checkcommand--timeout"></a>`timeout`

Data type: `Optional[Icinga2::Interval]`

The command timeout in seconds.

Default value: `undef`

##### <a name="-icinga2--object--checkcommand--arguments"></a>`arguments`

Data type: `Optional[Variant[Hash, String]]`

A dictionary of command arguments.

Default value: `undef`

##### <a name="-icinga2--object--checkcommand--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--checkcommand--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--checkcommand--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `15`

##### <a name="-icinga2--object--checkcommand--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--checkresultreader"></a>`icinga2::object::checkresultreader`

Manage Icinga 2 CheckResultReader objects.

#### Parameters

The following parameters are available in the `icinga2::object::checkresultreader` defined type:

* [`ensure`](#-icinga2--object--checkresultreader--ensure)
* [`checkresultreader_name`](#-icinga2--object--checkresultreader--checkresultreader_name)
* [`spool_dir`](#-icinga2--object--checkresultreader--spool_dir)
* [`target`](#-icinga2--object--checkresultreader--target)
* [`order`](#-icinga2--object--checkresultreader--order)

##### <a name="-icinga2--object--checkresultreader--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--checkresultreader--checkresultreader_name"></a>`checkresultreader_name`

Data type: `String`

Set the Icinga 2 name of the ceckresultreader object.

Default value: `$title`

##### <a name="-icinga2--object--checkresultreader--spool_dir"></a>`spool_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory which contains the check result files.

Default value: `undef`

##### <a name="-icinga2--object--checkresultreader--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--checkresultreader--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `'05'`

### <a name="icinga2--object--dependency"></a>`icinga2::object::dependency`

Manage Icinga 2 dependency objects.

#### Parameters

The following parameters are available in the `icinga2::object::dependency` defined type:

* [`ensure`](#-icinga2--object--dependency--ensure)
* [`dependency_name`](#-icinga2--object--dependency--dependency_name)
* [`parent_host_name`](#-icinga2--object--dependency--parent_host_name)
* [`parent_service_name`](#-icinga2--object--dependency--parent_service_name)
* [`child_host_name`](#-icinga2--object--dependency--child_host_name)
* [`child_service_name`](#-icinga2--object--dependency--child_service_name)
* [`disable_checks`](#-icinga2--object--dependency--disable_checks)
* [`disable_notifications`](#-icinga2--object--dependency--disable_notifications)
* [`ignore_soft_states`](#-icinga2--object--dependency--ignore_soft_states)
* [`period`](#-icinga2--object--dependency--period)
* [`states`](#-icinga2--object--dependency--states)
* [`apply`](#-icinga2--object--dependency--apply)
* [`prefix`](#-icinga2--object--dependency--prefix)
* [`apply_target`](#-icinga2--object--dependency--apply_target)
* [`assign`](#-icinga2--object--dependency--assign)
* [`ignore`](#-icinga2--object--dependency--ignore)
* [`template`](#-icinga2--object--dependency--template)
* [`import`](#-icinga2--object--dependency--import)
* [`target`](#-icinga2--object--dependency--target)
* [`order`](#-icinga2--object--dependency--order)
* [`export`](#-icinga2--object--dependency--export)

##### <a name="-icinga2--object--dependency--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--dependency--dependency_name"></a>`dependency_name`

Data type: `String`

Set the Icinga 2 name of the dependency object.

Default value: `$title`

##### <a name="-icinga2--object--dependency--parent_host_name"></a>`parent_host_name`

Data type: `Optional[String]`

The parent host.

Default value: `undef`

##### <a name="-icinga2--object--dependency--parent_service_name"></a>`parent_service_name`

Data type: `Optional[String]`

The parent service. If omitted, this dependency object is treated as host
dependency.

Default value: `undef`

##### <a name="-icinga2--object--dependency--child_host_name"></a>`child_host_name`

Data type: `Optional[String]`

The child host.

Default value: `undef`

##### <a name="-icinga2--object--dependency--child_service_name"></a>`child_service_name`

Data type: `Optional[String]`

The child service. If omitted, this dependency object is treated as host
dependency.

Default value: `undef`

##### <a name="-icinga2--object--dependency--disable_checks"></a>`disable_checks`

Data type: `Optional[Boolean]`

Whether to disable checks when this dependency fails.

Default value: `undef`

##### <a name="-icinga2--object--dependency--disable_notifications"></a>`disable_notifications`

Data type: `Optional[Boolean]`

Whether to disable notifications when this dependency fails.
true.

Default value: `undef`

##### <a name="-icinga2--object--dependency--ignore_soft_states"></a>`ignore_soft_states`

Data type: `Optional[Boolean]`

Whether to ignore soft states for the reachability calculation.
true.

Default value: `undef`

##### <a name="-icinga2--object--dependency--period"></a>`period`

Data type: `Optional[String]`

Time period during which this dependency is enabled.

Default value: `undef`

##### <a name="-icinga2--object--dependency--states"></a>`states`

Data type: `Optional[Array]`

A list of state filters when this dependency should be OK.

Default value: `undef`

##### <a name="-icinga2--object--dependency--apply"></a>`apply`

Data type: `Variant[Boolean, String]`

Dispose an apply instead an object if set to 'true'. Value is taken as statement,
i.e. 'vhost => config in host.vars.vhosts'.

Default value: `false`

##### <a name="-icinga2--object--dependency--prefix"></a>`prefix`

Data type: `Variant[Boolean, String]`

Set dependency_name as prefix in front of 'apply for'. Only effects if apply is a string.

Default value: `false`

##### <a name="-icinga2--object--dependency--apply_target"></a>`apply_target`

Data type: `Enum['Host', 'Service']`

An object type on which to target the apply rule. Valid values are `Host`
and `Service`.

Default value: `'Host'`

##### <a name="-icinga2--object--dependency--assign"></a>`assign`

Data type: `Array`

Assign user group members using the group assign rules.

Default value: `[]`

##### <a name="-icinga2--object--dependency--ignore"></a>`ignore`

Data type: `Array`

Exclude users using the group ignore rules.

Default value: `[]`

##### <a name="-icinga2--object--dependency--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--dependency--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--dependency--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--dependency--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `70`

##### <a name="-icinga2--object--dependency--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--endpoint"></a>`icinga2::object::endpoint`

Manage Icinga 2 endpoint objects.

#### Parameters

The following parameters are available in the `icinga2::object::endpoint` defined type:

* [`ensure`](#-icinga2--object--endpoint--ensure)
* [`endpoint_name`](#-icinga2--object--endpoint--endpoint_name)
* [`host`](#-icinga2--object--endpoint--host)
* [`port`](#-icinga2--object--endpoint--port)
* [`log_duration`](#-icinga2--object--endpoint--log_duration)
* [`target`](#-icinga2--object--endpoint--target)
* [`order`](#-icinga2--object--endpoint--order)
* [`export`](#-icinga2--object--endpoint--export)

##### <a name="-icinga2--object--endpoint--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--endpoint--endpoint_name"></a>`endpoint_name`

Data type: `String`

Set the Icinga 2 name of the endpoint object.

Default value: `$title`

##### <a name="-icinga2--object--endpoint--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

Optional. The IP address of the remote Icinga 2 instance.

Default value: `undef`

##### <a name="-icinga2--object--endpoint--port"></a>`port`

Data type: `Optional[Stdlib::Port::Unprivileged]`

The service name/port of the remote Icinga 2 instance.

Default value: `undef`

##### <a name="-icinga2--object--endpoint--log_duration"></a>`log_duration`

Data type: `Optional[Icinga2::Interval]`

Duration for keeping replay logs on connection loss.
Attribute is specified in seconds. If log_duration is set to 0, replaying logs is disabled.
You could also specify the value in human readable format like 10m for 10 minutes
or 1h for one hour.

Default value: `undef`

##### <a name="-icinga2--object--endpoint--target"></a>`target`

Data type: `Optional[Stdlib::Absolutepath]`

Destination config file to store in this object. File will be declared at the
first time.

Default value: `undef`

##### <a name="-icinga2--object--endpoint--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `40`

##### <a name="-icinga2--object--endpoint--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--eventcommand"></a>`icinga2::object::eventcommand`

Manage Icinga 2 EventCommand objects.

#### Parameters

The following parameters are available in the `icinga2::object::eventcommand` defined type:

* [`ensure`](#-icinga2--object--eventcommand--ensure)
* [`eventcommand_name`](#-icinga2--object--eventcommand--eventcommand_name)
* [`command`](#-icinga2--object--eventcommand--command)
* [`env`](#-icinga2--object--eventcommand--env)
* [`vars`](#-icinga2--object--eventcommand--vars)
* [`timeout`](#-icinga2--object--eventcommand--timeout)
* [`arguments`](#-icinga2--object--eventcommand--arguments)
* [`target`](#-icinga2--object--eventcommand--target)
* [`import`](#-icinga2--object--eventcommand--import)
* [`order`](#-icinga2--object--eventcommand--order)
* [`export`](#-icinga2--object--eventcommand--export)

##### <a name="-icinga2--object--eventcommand--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--eventcommand--eventcommand_name"></a>`eventcommand_name`

Data type: `String`

Set the Icinga 2 name of the eventcommand object.

Default value: `$title`

##### <a name="-icinga2--object--eventcommand--command"></a>`command`

Data type: `Optional[Variant[Array, String]]`

The command. This can either be an array of individual command arguments.
Alternatively a string can be specified in which case the shell interpreter (usually /bin/sh)
takes care of parsing the command.

Default value: `undef`

##### <a name="-icinga2--object--eventcommand--env"></a>`env`

Data type: `Optional[Hash]`

A dictionary of macros which should be exported as environment variables prior to executing the command.

Default value: `undef`

##### <a name="-icinga2--object--eventcommand--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--eventcommand--timeout"></a>`timeout`

Data type: `Optional[Icinga2::Interval]`

The command timeout in seconds.

Default value: `undef`

##### <a name="-icinga2--object--eventcommand--arguments"></a>`arguments`

Data type: `Optional[Hash]`

A dictionary of command arguments.

Default value: `undef`

##### <a name="-icinga2--object--eventcommand--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--eventcommand--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--eventcommand--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `20`

##### <a name="-icinga2--object--eventcommand--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--host"></a>`icinga2::object::host`

Manage Icinga 2 Host objects.

#### Parameters

The following parameters are available in the `icinga2::object::host` defined type:

* [`ensure`](#-icinga2--object--host--ensure)
* [`host_name`](#-icinga2--object--host--host_name)
* [`import`](#-icinga2--object--host--import)
* [`display_name`](#-icinga2--object--host--display_name)
* [`address`](#-icinga2--object--host--address)
* [`address6`](#-icinga2--object--host--address6)
* [`vars`](#-icinga2--object--host--vars)
* [`groups`](#-icinga2--object--host--groups)
* [`check_command`](#-icinga2--object--host--check_command)
* [`max_check_attempts`](#-icinga2--object--host--max_check_attempts)
* [`check_period`](#-icinga2--object--host--check_period)
* [`check_timeout`](#-icinga2--object--host--check_timeout)
* [`check_interval`](#-icinga2--object--host--check_interval)
* [`retry_interval`](#-icinga2--object--host--retry_interval)
* [`enable_notifications`](#-icinga2--object--host--enable_notifications)
* [`enable_active_checks`](#-icinga2--object--host--enable_active_checks)
* [`enable_passive_checks`](#-icinga2--object--host--enable_passive_checks)
* [`enable_event_handler`](#-icinga2--object--host--enable_event_handler)
* [`enable_flapping`](#-icinga2--object--host--enable_flapping)
* [`enable_perfdata`](#-icinga2--object--host--enable_perfdata)
* [`event_command`](#-icinga2--object--host--event_command)
* [`flapping_threshold_low`](#-icinga2--object--host--flapping_threshold_low)
* [`flapping_threshold_high`](#-icinga2--object--host--flapping_threshold_high)
* [`volatile`](#-icinga2--object--host--volatile)
* [`zone`](#-icinga2--object--host--zone)
* [`command_endpoint`](#-icinga2--object--host--command_endpoint)
* [`notes`](#-icinga2--object--host--notes)
* [`notes_url`](#-icinga2--object--host--notes_url)
* [`action_url`](#-icinga2--object--host--action_url)
* [`icon_image`](#-icinga2--object--host--icon_image)
* [`icon_image_alt`](#-icinga2--object--host--icon_image_alt)
* [`template`](#-icinga2--object--host--template)
* [`target`](#-icinga2--object--host--target)
* [`order`](#-icinga2--object--host--order)
* [`export`](#-icinga2--object--host--export)

##### <a name="-icinga2--object--host--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--host--host_name"></a>`host_name`

Data type: `String`

Hostname of the Host object.

Default value: `$title`

##### <a name="-icinga2--object--host--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--host--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the host (e.g. displayed by external interfaces instead of the name if set).

Default value: `undef`

##### <a name="-icinga2--object--host--address"></a>`address`

Data type: `Optional[Stdlib::Host]`

The host's address v4.

Default value: `undef`

##### <a name="-icinga2--object--host--address6"></a>`address6`

Data type: `Optional[Stdlib::Host]`

The host's address v6.

Default value: `undef`

##### <a name="-icinga2--object--host--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--host--groups"></a>`groups`

Data type: `Optional[Array]`

A list of host groups this host belongs to.

Default value: `undef`

##### <a name="-icinga2--object--host--check_command"></a>`check_command`

Data type: `Optional[String]`

The name of the check command.

Default value: `undef`

##### <a name="-icinga2--object--host--max_check_attempts"></a>`max_check_attempts`

Data type: `Optional[Integer[1]]`

The number of times a host is re-checked before changing into a hard state.

Default value: `undef`

##### <a name="-icinga2--object--host--check_period"></a>`check_period`

Data type: `Optional[String]`

The name of a time period which determines when this host should be checked.

Default value: `undef`

##### <a name="-icinga2--object--host--check_timeout"></a>`check_timeout`

Data type: `Optional[Icinga2::Interval]`

Check command timeout in seconds. Overrides the CheckCommand's timeout attribute.

Default value: `undef`

##### <a name="-icinga2--object--host--check_interval"></a>`check_interval`

Data type: `Optional[Icinga2::Interval]`

The check interval (in seconds). This interval is used for checks when the host is in a HARD state.

Default value: `undef`

##### <a name="-icinga2--object--host--retry_interval"></a>`retry_interval`

Data type: `Optional[Icinga2::Interval]`

The retry interval (in seconds). This interval is used for checks when the host is in a SOFT state.

Default value: `undef`

##### <a name="-icinga2--object--host--enable_notifications"></a>`enable_notifications`

Data type: `Optional[Boolean]`

Whether notifications are enabled.

Default value: `undef`

##### <a name="-icinga2--object--host--enable_active_checks"></a>`enable_active_checks`

Data type: `Optional[Boolean]`

Whether active checks are enabled.

Default value: `undef`

##### <a name="-icinga2--object--host--enable_passive_checks"></a>`enable_passive_checks`

Data type: `Optional[Boolean]`

Whether passive checks are enabled.

Default value: `undef`

##### <a name="-icinga2--object--host--enable_event_handler"></a>`enable_event_handler`

Data type: `Optional[Boolean]`

Enables event handlers for this host.

Default value: `undef`

##### <a name="-icinga2--object--host--enable_flapping"></a>`enable_flapping`

Data type: `Optional[Boolean]`

Whether flap detection is enabled.

Default value: `undef`

##### <a name="-icinga2--object--host--enable_perfdata"></a>`enable_perfdata`

Data type: `Optional[Boolean]`

Whether performance data processing is enabled.

Default value: `undef`

##### <a name="-icinga2--object--host--event_command"></a>`event_command`

Data type: `Optional[String]`

The name of an event command that should be executed every time the host's
state changes or the host is in a SOFT state.

Default value: `undef`

##### <a name="-icinga2--object--host--flapping_threshold_low"></a>`flapping_threshold_low`

Data type: `Optional[Integer[1]]`

Flapping lower bound in percent for a host to be considered not flapping.

Default value: `undef`

##### <a name="-icinga2--object--host--flapping_threshold_high"></a>`flapping_threshold_high`

Data type: `Optional[Integer[1]]`

Flapping upper bound in percent for a host to be considered flapping.

Default value: `undef`

##### <a name="-icinga2--object--host--volatile"></a>`volatile`

Data type: `Optional[Boolean]`

The volatile setting enables always HARD state types if NOT-OK state changes occur.

Default value: `undef`

##### <a name="-icinga2--object--host--zone"></a>`zone`

Data type: `Optional[String]`

The zone this object is a member of.

Default value: `undef`

##### <a name="-icinga2--object--host--command_endpoint"></a>`command_endpoint`

Data type: `Optional[String]`

The endpoint where commands are executed on.

Default value: `undef`

##### <a name="-icinga2--object--host--notes"></a>`notes`

Data type: `Optional[String]`

Notes for the host.

Default value: `undef`

##### <a name="-icinga2--object--host--notes_url"></a>`notes_url`

Data type: `Optional[String]`

Url for notes for the host (for example, in notification commands).

Default value: `undef`

##### <a name="-icinga2--object--host--action_url"></a>`action_url`

Data type: `Optional[String]`

Url for actions for the host (for example, an external graphing tool).

Default value: `undef`

##### <a name="-icinga2--object--host--icon_image"></a>`icon_image`

Data type: `Optional[String]`

Icon image for the host. Used by external interfaces only.

Default value: `undef`

##### <a name="-icinga2--object--host--icon_image_alt"></a>`icon_image_alt`

Data type: `Optional[String]`

Icon image description for the host. Used by external interface only.

Default value: `undef`

##### <a name="-icinga2--object--host--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--host--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--host--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `50`

##### <a name="-icinga2--object--host--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--hostgroup"></a>`icinga2::object::hostgroup`

Manage Icinga 2 HostGroup objects.

#### Examples

##### 

```puppet
icinga2::object::hostgroup { 'monitoring-hosts':
  display_name => 'Linux Servers',
  groups       => [ 'linux-servers' ],
  target       => '/etc/icinga2/conf.d/groups2.conf',
  assign       => [ 'host.name == NodeName' ],
}
```

#### Parameters

The following parameters are available in the `icinga2::object::hostgroup` defined type:

* [`ensure`](#-icinga2--object--hostgroup--ensure)
* [`hostgroup_name`](#-icinga2--object--hostgroup--hostgroup_name)
* [`display_name`](#-icinga2--object--hostgroup--display_name)
* [`groups`](#-icinga2--object--hostgroup--groups)
* [`assign`](#-icinga2--object--hostgroup--assign)
* [`ignore`](#-icinga2--object--hostgroup--ignore)
* [`target`](#-icinga2--object--hostgroup--target)
* [`order`](#-icinga2--object--hostgroup--order)
* [`export`](#-icinga2--object--hostgroup--export)

##### <a name="-icinga2--object--hostgroup--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--hostgroup--hostgroup_name"></a>`hostgroup_name`

Data type: `String`

Namevar of the hostgroup.

Default value: `$title`

##### <a name="-icinga2--object--hostgroup--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the host group.

Default value: `undef`

##### <a name="-icinga2--object--hostgroup--groups"></a>`groups`

Data type: `Optional[Array]`

An array of nested group names.

Default value: `undef`

##### <a name="-icinga2--object--hostgroup--assign"></a>`assign`

Data type: `Array`

Assign host group members using the group rules.

Default value: `[]`

##### <a name="-icinga2--object--hostgroup--ignore"></a>`ignore`

Data type: `Array`

Ignore host group members using the group rules.

Default value: `[]`

##### <a name="-icinga2--object--hostgroup--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared at the
first time.

##### <a name="-icinga2--object--hostgroup--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `55`

##### <a name="-icinga2--object--hostgroup--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--icingaapplication"></a>`icinga2::object::icingaapplication`

Manage Icinga 2 IcingaApplication objects.

#### Parameters

The following parameters are available in the `icinga2::object::icingaapplication` defined type:

* [`ensure`](#-icinga2--object--icingaapplication--ensure)
* [`app_name`](#-icinga2--object--icingaapplication--app_name)
* [`enable_notifications`](#-icinga2--object--icingaapplication--enable_notifications)
* [`enable_event_handlers`](#-icinga2--object--icingaapplication--enable_event_handlers)
* [`enable_flapping`](#-icinga2--object--icingaapplication--enable_flapping)
* [`enable_host_checks`](#-icinga2--object--icingaapplication--enable_host_checks)
* [`enable_service_checks`](#-icinga2--object--icingaapplication--enable_service_checks)
* [`enable_perfdata`](#-icinga2--object--icingaapplication--enable_perfdata)
* [`vars`](#-icinga2--object--icingaapplication--vars)
* [`environment`](#-icinga2--object--icingaapplication--environment)
* [`target`](#-icinga2--object--icingaapplication--target)
* [`order`](#-icinga2--object--icingaapplication--order)
* [`export`](#-icinga2--object--icingaapplication--export)

##### <a name="-icinga2--object--icingaapplication--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--icingaapplication--app_name"></a>`app_name`

Data type: `String`

Set the Icinga 2 name of the IcingaApplication object.

Default value: `$title`

##### <a name="-icinga2--object--icingaapplication--enable_notifications"></a>`enable_notifications`

Data type: `Optional[Boolean]`

Whether notifications are globally enabled.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--enable_event_handlers"></a>`enable_event_handlers`

Data type: `Optional[Boolean]`

Whether event handlers are globally enabled.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--enable_flapping"></a>`enable_flapping`

Data type: `Optional[Boolean]`

Whether flap detection is globally enabled.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--enable_host_checks"></a>`enable_host_checks`

Data type: `Optional[Boolean]`

Whether active host checks are globally enabled.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--enable_service_checks"></a>`enable_service_checks`

Data type: `Optional[Boolean]`

Whether active service checks are globally enabled.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--enable_perfdata"></a>`enable_perfdata`

Data type: `Optional[Boolean]`

Whether performance data processing is globally enabled.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--environment"></a>`environment`

Data type: `Optional[String]`

Specify the Icinga environment. This overrides the Environment constant
specified in the configuration or on the CLI with --define.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--target"></a>`target`

Data type: `Optional[Stdlib::Absolutepath]`

Destination config file to store in this object. File will be declared at the
first time.

Default value: `undef`

##### <a name="-icinga2--object--icingaapplication--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to control the position in the target file, sorted alpha numeric.

Default value: `5`

##### <a name="-icinga2--object--icingaapplication--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--notification"></a>`icinga2::object::notification`

Manage Icinga 2 notification objects.

#### Parameters

The following parameters are available in the `icinga2::object::notification` defined type:

* [`ensure`](#-icinga2--object--notification--ensure)
* [`notification_name`](#-icinga2--object--notification--notification_name)
* [`host_name`](#-icinga2--object--notification--host_name)
* [`service_name`](#-icinga2--object--notification--service_name)
* [`vars`](#-icinga2--object--notification--vars)
* [`users`](#-icinga2--object--notification--users)
* [`user_groups`](#-icinga2--object--notification--user_groups)
* [`times`](#-icinga2--object--notification--times)
* [`command`](#-icinga2--object--notification--command)
* [`interval`](#-icinga2--object--notification--interval)
* [`period`](#-icinga2--object--notification--period)
* [`zone`](#-icinga2--object--notification--zone)
* [`types`](#-icinga2--object--notification--types)
* [`states`](#-icinga2--object--notification--states)
* [`template`](#-icinga2--object--notification--template)
* [`apply`](#-icinga2--object--notification--apply)
* [`prefix`](#-icinga2--object--notification--prefix)
* [`apply_target`](#-icinga2--object--notification--apply_target)
* [`import`](#-icinga2--object--notification--import)
* [`target`](#-icinga2--object--notification--target)
* [`order`](#-icinga2--object--notification--order)
* [`assign`](#-icinga2--object--notification--assign)
* [`ignore`](#-icinga2--object--notification--ignore)
* [`export`](#-icinga2--object--notification--export)

##### <a name="-icinga2--object--notification--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--notification--notification_name"></a>`notification_name`

Data type: `String`

Set the Icinga 2 name of the notification object.

Default value: `$title`

##### <a name="-icinga2--object--notification--host_name"></a>`host_name`

Data type: `Optional[String]`

The name of the host this notification belongs to.

Default value: `undef`

##### <a name="-icinga2--object--notification--service_name"></a>`service_name`

Data type: `Optional[String]`

The short name of the service this notification belongs to. If omitted, this
notification object is treated as host notification.

Default value: `undef`

##### <a name="-icinga2--object--notification--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--notification--users"></a>`users`

Data type: `Optional[Variant[String, Array]]`

A list of user names who should be notified.

Default value: `undef`

##### <a name="-icinga2--object--notification--user_groups"></a>`user_groups`

Data type: `Optional[Variant[String, Array]]`

A list of user group names who should be notified.

Default value: `undef`

##### <a name="-icinga2--object--notification--times"></a>`times`

Data type: `Optional[Hash]`

A dictionary containing begin and end attributes for the notification.

Default value: `undef`

##### <a name="-icinga2--object--notification--command"></a>`command`

Data type: `Optional[String]`

The name of the notification command which should be executed when the
notification is triggered.

Default value: `undef`

##### <a name="-icinga2--object--notification--interval"></a>`interval`

Data type: `Optional[Variant[Icinga2::Interval,Pattern[/(host|service)\./]]]`

The notification interval (in seconds). This interval is used for active
notifications.

Default value: `undef`

##### <a name="-icinga2--object--notification--period"></a>`period`

Data type: `Optional[String]`

The name of a time period which determines when this notification should be
triggered.

Default value: `undef`

##### <a name="-icinga2--object--notification--zone"></a>`zone`

Data type: `Optional[String]`

The zone this object is a member of.

Default value: `undef`

##### <a name="-icinga2--object--notification--types"></a>`types`

Data type: `Optional[Variant[Array, String]]`

A list of type filters when this notification should be triggered.

Default value: `undef`

##### <a name="-icinga2--object--notification--states"></a>`states`

Data type: `Optional[Variant[Array, String]]`

A list of state filters when this notification should be triggered.

Default value: `undef`

##### <a name="-icinga2--object--notification--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--notification--apply"></a>`apply`

Data type: `Variant[Boolean, String]`

Dispose an apply instead an object if set to 'true'. Value is taken as statement,
i.e. 'vhost => config in host.vars.vhosts'.

Default value: `false`

##### <a name="-icinga2--object--notification--prefix"></a>`prefix`

Data type: `Variant[Boolean, String]`

Set notification_name as prefix in front of 'apply for'. Only effects if apply is a string.

Default value: `false`

##### <a name="-icinga2--object--notification--apply_target"></a>`apply_target`

Data type: `Enum['Host', 'Service']`

An object type on which to target the apply rule. Valid values are `Host` and `Service`.

Default value: `'Host'`

##### <a name="-icinga2--object--notification--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--notification--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--notification--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `85`

##### <a name="-icinga2--object--notification--assign"></a>`assign`

Data type: `Array`

Assign notification using the assign rules.

Default value: `[]`

##### <a name="-icinga2--object--notification--ignore"></a>`ignore`

Data type: `Array`

Exclude notification using the ignore rules.

Default value: `[]`

##### <a name="-icinga2--object--notification--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--notificationcommand"></a>`icinga2::object::notificationcommand`

Manage Icinga 2 notificationcommand objects.

#### Parameters

The following parameters are available in the `icinga2::object::notificationcommand` defined type:

* [`ensure`](#-icinga2--object--notificationcommand--ensure)
* [`notificationcommand_name`](#-icinga2--object--notificationcommand--notificationcommand_name)
* [`command`](#-icinga2--object--notificationcommand--command)
* [`env`](#-icinga2--object--notificationcommand--env)
* [`vars`](#-icinga2--object--notificationcommand--vars)
* [`timeout`](#-icinga2--object--notificationcommand--timeout)
* [`arguments`](#-icinga2--object--notificationcommand--arguments)
* [`template`](#-icinga2--object--notificationcommand--template)
* [`import`](#-icinga2--object--notificationcommand--import)
* [`target`](#-icinga2--object--notificationcommand--target)
* [`order`](#-icinga2--object--notificationcommand--order)
* [`export`](#-icinga2--object--notificationcommand--export)

##### <a name="-icinga2--object--notificationcommand--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--notificationcommand--notificationcommand_name"></a>`notificationcommand_name`

Data type: `String`

Set the Icinga 2 name of the notificationcommand object.

Default value: `$title`

##### <a name="-icinga2--object--notificationcommand--command"></a>`command`

Data type: `Optional[Variant[Array, String]]`

The command. This can either be an array of individual command arguments.
Alternatively a string can be specified in which case the shell interpreter
(usually /bin/sh) takes care of parsing the command.

Default value: `undef`

##### <a name="-icinga2--object--notificationcommand--env"></a>`env`

Data type: `Optional[Hash]`

A dictionary of macros which should be exported as environment variables
prior to executing the command.

Default value: `undef`

##### <a name="-icinga2--object--notificationcommand--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--notificationcommand--timeout"></a>`timeout`

Data type: `Optional[Icinga2::Interval]`

The command timeout in seconds.

Default value: `undef`

##### <a name="-icinga2--object--notificationcommand--arguments"></a>`arguments`

Data type: `Optional[Hash]`

A dictionary of command arguments.

Default value: `undef`

##### <a name="-icinga2--object--notificationcommand--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--notificationcommand--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--notificationcommand--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--notificationcommand--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `25`

##### <a name="-icinga2--object--notificationcommand--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--scheduleddowntime"></a>`icinga2::object::scheduleddowntime`

Manage Icinga 2 scheduleddowntime objects.

#### Parameters

The following parameters are available in the `icinga2::object::scheduleddowntime` defined type:

* [`ensure`](#-icinga2--object--scheduleddowntime--ensure)
* [`scheduleddowntime_name`](#-icinga2--object--scheduleddowntime--scheduleddowntime_name)
* [`host_name`](#-icinga2--object--scheduleddowntime--host_name)
* [`service_name`](#-icinga2--object--scheduleddowntime--service_name)
* [`author`](#-icinga2--object--scheduleddowntime--author)
* [`comment`](#-icinga2--object--scheduleddowntime--comment)
* [`fixed`](#-icinga2--object--scheduleddowntime--fixed)
* [`duration`](#-icinga2--object--scheduleddowntime--duration)
* [`ranges`](#-icinga2--object--scheduleddowntime--ranges)
* [`apply`](#-icinga2--object--scheduleddowntime--apply)
* [`prefix`](#-icinga2--object--scheduleddowntime--prefix)
* [`apply_target`](#-icinga2--object--scheduleddowntime--apply_target)
* [`assign`](#-icinga2--object--scheduleddowntime--assign)
* [`ignore`](#-icinga2--object--scheduleddowntime--ignore)
* [`target`](#-icinga2--object--scheduleddowntime--target)
* [`order`](#-icinga2--object--scheduleddowntime--order)
* [`export`](#-icinga2--object--scheduleddowntime--export)

##### <a name="-icinga2--object--scheduleddowntime--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--scheduleddowntime--scheduleddowntime_name"></a>`scheduleddowntime_name`

Data type: `String`

Set the Icinga 2 name of the scheduleddowntime object.

Default value: `$title`

##### <a name="-icinga2--object--scheduleddowntime--host_name"></a>`host_name`

Data type: `Optional[String]`

The name of the host this comment belongs to.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--service_name"></a>`service_name`

Data type: `Optional[String]`

The short name of the service this comment belongs to. If omitted, this comment object is treated as host comment.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--author"></a>`author`

Data type: `Optional[String]`

The author's name.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--comment"></a>`comment`

Data type: `Optional[String]`

The comment text.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--fixed"></a>`fixed`

Data type: `Optional[Boolean]`

Whether this is a fixed downtime.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--duration"></a>`duration`

Data type: `Optional[Icinga2::Interval]`

The duration as number.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--ranges"></a>`ranges`

Data type: `Optional[Hash]`

A dictionary containing information which days and durations apply to this timeperiod.

Default value: `undef`

##### <a name="-icinga2--object--scheduleddowntime--apply"></a>`apply`

Data type: `Variant[Boolean, String]`

Dispose an apply instead an object if set to 'true'. Value is taken as statement,
i.e. 'vhost => config in host.vars.vhosts'.

Default value: `false`

##### <a name="-icinga2--object--scheduleddowntime--prefix"></a>`prefix`

Data type: `Variant[Boolean, String]`

Set scheduleddowntime_name as prefix in front of 'apply for'. Only effects if apply is a string.

Default value: `false`

##### <a name="-icinga2--object--scheduleddowntime--apply_target"></a>`apply_target`

Data type: `Enum['Host', 'Service']`

An object type on which to target the apply rule. Valid values are `Host` and `Service`.

Default value: `'Host'`

##### <a name="-icinga2--object--scheduleddowntime--assign"></a>`assign`

Data type: `Array`

Assign user group members using the group assign rules.

Default value: `[]`

##### <a name="-icinga2--object--scheduleddowntime--ignore"></a>`ignore`

Data type: `Array`

Exclude users using the group ignore rules.

Default value: `[]`

##### <a name="-icinga2--object--scheduleddowntime--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--scheduleddowntime--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `90`

##### <a name="-icinga2--object--scheduleddowntime--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--service"></a>`icinga2::object::service`

Manage Icinga 2 service objects.

#### Examples

##### A service `ping` is applied to all hosts with a valid ipv4 address.

```puppet
::icinga2::object::service { 'ping4':
  import        => ['generic-service'],
  apply         => true,
  check_command => 'ping',
  assign        => ['host.address'],
  target        => '/etc/icinga2/zones.d/global-templates/services.conf',
}
```

##### A `apply Service for (disk_name =>config in host.vars.disks)` rule is applied to all Linux hosts with an Icinga Agent. Note in this example it's required that the endpoint (see `command_endpoint`) and the host object has the same name!

```puppet
::icinga2::object::service { 'linux_disks':
  import           => ['generic-service'],
  apply            =>  'disk_name => config in host.vars.disks',
  check_command    => 'disk',
  command_endpoint => 'host.name',
  vars             => '+ config',
  assign           => ['host.vars.os == Linux'],
  ignore           => ['host.vars.noagent'],
  target           => '/etc/icinga2/zones.d/global-templates/services.conf',
}
```

#### Parameters

The following parameters are available in the `icinga2::object::service` defined type:

* [`ensure`](#-icinga2--object--service--ensure)
* [`service_name`](#-icinga2--object--service--service_name)
* [`display_name`](#-icinga2--object--service--display_name)
* [`host_name`](#-icinga2--object--service--host_name)
* [`groups`](#-icinga2--object--service--groups)
* [`vars`](#-icinga2--object--service--vars)
* [`check_command`](#-icinga2--object--service--check_command)
* [`max_check_attempts`](#-icinga2--object--service--max_check_attempts)
* [`check_period`](#-icinga2--object--service--check_period)
* [`check_timeout`](#-icinga2--object--service--check_timeout)
* [`check_interval`](#-icinga2--object--service--check_interval)
* [`retry_interval`](#-icinga2--object--service--retry_interval)
* [`enable_notifications`](#-icinga2--object--service--enable_notifications)
* [`enable_active_checks`](#-icinga2--object--service--enable_active_checks)
* [`enable_passive_checks`](#-icinga2--object--service--enable_passive_checks)
* [`enable_event_handler`](#-icinga2--object--service--enable_event_handler)
* [`enable_flapping`](#-icinga2--object--service--enable_flapping)
* [`enable_perfdata`](#-icinga2--object--service--enable_perfdata)
* [`event_command`](#-icinga2--object--service--event_command)
* [`flapping_threshold_low`](#-icinga2--object--service--flapping_threshold_low)
* [`flapping_threshold_high`](#-icinga2--object--service--flapping_threshold_high)
* [`volatile`](#-icinga2--object--service--volatile)
* [`zone`](#-icinga2--object--service--zone)
* [`command_endpoint`](#-icinga2--object--service--command_endpoint)
* [`notes`](#-icinga2--object--service--notes)
* [`notes_url`](#-icinga2--object--service--notes_url)
* [`action_url`](#-icinga2--object--service--action_url)
* [`icon_image`](#-icinga2--object--service--icon_image)
* [`icon_image_alt`](#-icinga2--object--service--icon_image_alt)
* [`template`](#-icinga2--object--service--template)
* [`apply`](#-icinga2--object--service--apply)
* [`prefix`](#-icinga2--object--service--prefix)
* [`assign`](#-icinga2--object--service--assign)
* [`ignore`](#-icinga2--object--service--ignore)
* [`import`](#-icinga2--object--service--import)
* [`target`](#-icinga2--object--service--target)
* [`order`](#-icinga2--object--service--order)
* [`export`](#-icinga2--object--service--export)

##### <a name="-icinga2--object--service--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--service--service_name"></a>`service_name`

Data type: `String`

Set the Icinga 2 name of the service object.

Default value: `$title`

##### <a name="-icinga2--object--service--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the service.

Default value: `undef`

##### <a name="-icinga2--object--service--host_name"></a>`host_name`

Data type: `Optional[String]`

The host this service belongs to. There must be a Host object with
that name.

Default value: `undef`

##### <a name="-icinga2--object--service--groups"></a>`groups`

Data type: `Optional[Array]`

The service groups this service belongs to.

Default value: `undef`

##### <a name="-icinga2--object--service--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--service--check_command"></a>`check_command`

Data type: `Optional[String]`

The name of the check command.

Default value: `undef`

##### <a name="-icinga2--object--service--max_check_attempts"></a>`max_check_attempts`

Data type: `Optional[Integer[1]]`

The number of times a service is re-checked before changing into a hard
state.

Default value: `undef`

##### <a name="-icinga2--object--service--check_period"></a>`check_period`

Data type: `Optional[String]`

The name of a time period which determines when this service should be
checked.

Default value: `undef`

##### <a name="-icinga2--object--service--check_timeout"></a>`check_timeout`

Data type: `Optional[Icinga2::Interval]`

Check command timeout in seconds. Overrides the CheckCommand's timeout
attribute.

Default value: `undef`

##### <a name="-icinga2--object--service--check_interval"></a>`check_interval`

Data type: `Optional[Icinga2::Interval]`

The check interval (in seconds). This interval is used for checks when the
service is in a HARD state.

Default value: `undef`

##### <a name="-icinga2--object--service--retry_interval"></a>`retry_interval`

Data type: `Optional[Icinga2::Interval]`

The retry interval (in seconds). This interval is used for checks when the
service is in a SOFT state.

Default value: `undef`

##### <a name="-icinga2--object--service--enable_notifications"></a>`enable_notifications`

Data type: `Optional[Boolean]`

Whether notifications are enabled.

Default value: `undef`

##### <a name="-icinga2--object--service--enable_active_checks"></a>`enable_active_checks`

Data type: `Optional[Boolean]`

Whether active checks are enabled.

Default value: `undef`

##### <a name="-icinga2--object--service--enable_passive_checks"></a>`enable_passive_checks`

Data type: `Optional[Boolean]`

Whether passive checks are enabled.

Default value: `undef`

##### <a name="-icinga2--object--service--enable_event_handler"></a>`enable_event_handler`

Data type: `Optional[Boolean]`

Enables event handlers for this host.

Default value: `undef`

##### <a name="-icinga2--object--service--enable_flapping"></a>`enable_flapping`

Data type: `Optional[Boolean]`

Whether flap detection is enabled.

Default value: `undef`

##### <a name="-icinga2--object--service--enable_perfdata"></a>`enable_perfdata`

Data type: `Optional[Boolean]`

Whether performance data processing is enabled.

Default value: `undef`

##### <a name="-icinga2--object--service--event_command"></a>`event_command`

Data type: `Optional[String]`

The name of an event command that should be executed every time the
service's state changes or the service is in a SOFT state.

Default value: `undef`

##### <a name="-icinga2--object--service--flapping_threshold_low"></a>`flapping_threshold_low`

Data type: `Optional[Integer[1]]`

Flapping lower bound in percent for a host to be considered not flapping.

Default value: `undef`

##### <a name="-icinga2--object--service--flapping_threshold_high"></a>`flapping_threshold_high`

Data type: `Optional[Integer[1]]`

Flapping upper bound in percent for a host to be considered flapping.

Default value: `undef`

##### <a name="-icinga2--object--service--volatile"></a>`volatile`

Data type: `Optional[Boolean]`

The volatile setting enables always HARD state types if NOT-OK state changes
occur.

Default value: `undef`

##### <a name="-icinga2--object--service--zone"></a>`zone`

Data type: `Optional[String]`

The zone this object is a member of.

Default value: `undef`

##### <a name="-icinga2--object--service--command_endpoint"></a>`command_endpoint`

Data type: `Optional[String]`

The endpoint where commands are executed on.

Default value: `undef`

##### <a name="-icinga2--object--service--notes"></a>`notes`

Data type: `Optional[String]`

Notes for the service.

Default value: `undef`

##### <a name="-icinga2--object--service--notes_url"></a>`notes_url`

Data type: `Optional[String]`

Url for notes for the service (for example, in notification commands).

Default value: `undef`

##### <a name="-icinga2--object--service--action_url"></a>`action_url`

Data type: `Optional[String]`

Url for actions for the service (for example, an external graphing tool).

Default value: `undef`

##### <a name="-icinga2--object--service--icon_image"></a>`icon_image`

Data type: `Optional[String]`

Icon image for the service. Used by external interfaces only.

Default value: `undef`

##### <a name="-icinga2--object--service--icon_image_alt"></a>`icon_image_alt`

Data type: `Optional[String]`

Icon image description for the service. Used by external interface only.

Default value: `undef`

##### <a name="-icinga2--object--service--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--service--apply"></a>`apply`

Data type: `Variant[Boolean, String]`

Dispose an apply instead an object if set to 'true'. Value is taken as statement,
i.e. 'vhost => config in host.vars.vhosts'.

Default value: `false`

##### <a name="-icinga2--object--service--prefix"></a>`prefix`

Data type: `Variant[Boolean, String]`

Set service_name as prefix in front of 'apply for'. Only effects if apply is a string.

Default value: `false`

##### <a name="-icinga2--object--service--assign"></a>`assign`

Data type: `Array`

Assign service using the assign rules.

Default value: `[]`

##### <a name="-icinga2--object--service--ignore"></a>`ignore`

Data type: `Array`

Exclude service using the ignore rules.

Default value: `[]`

##### <a name="-icinga2--object--service--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--service--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--service--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `60`

##### <a name="-icinga2--object--service--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--servicegroup"></a>`icinga2::object::servicegroup`

Manage Icinga 2 servicegroup objects.

#### Parameters

The following parameters are available in the `icinga2::object::servicegroup` defined type:

* [`ensure`](#-icinga2--object--servicegroup--ensure)
* [`servicegroup_name`](#-icinga2--object--servicegroup--servicegroup_name)
* [`display_name`](#-icinga2--object--servicegroup--display_name)
* [`groups`](#-icinga2--object--servicegroup--groups)
* [`assign`](#-icinga2--object--servicegroup--assign)
* [`ignore`](#-icinga2--object--servicegroup--ignore)
* [`template`](#-icinga2--object--servicegroup--template)
* [`import`](#-icinga2--object--servicegroup--import)
* [`target`](#-icinga2--object--servicegroup--target)
* [`order`](#-icinga2--object--servicegroup--order)
* [`export`](#-icinga2--object--servicegroup--export)

##### <a name="-icinga2--object--servicegroup--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--servicegroup--servicegroup_name"></a>`servicegroup_name`

Data type: `String`

Set the Icinga 2 name of the servicegroup object.

Default value: `$title`

##### <a name="-icinga2--object--servicegroup--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the service group.

Default value: `undef`

##### <a name="-icinga2--object--servicegroup--groups"></a>`groups`

Data type: `Optional[Array]`

An array of nested group names.

Default value: `undef`

##### <a name="-icinga2--object--servicegroup--assign"></a>`assign`

Data type: `Array`

Assign user group members using the group assign rules.

Default value: `[]`

##### <a name="-icinga2--object--servicegroup--ignore"></a>`ignore`

Data type: `Array`

Exclude users using the group ignore rules.

Default value: `[]`

##### <a name="-icinga2--object--servicegroup--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--servicegroup--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--servicegroup--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--servicegroup--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `65`

##### <a name="-icinga2--object--servicegroup--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--timeperiod"></a>`icinga2::object::timeperiod`

Manage Icinga 2 timeperiod objects.

#### Parameters

The following parameters are available in the `icinga2::object::timeperiod` defined type:

* [`ensure`](#-icinga2--object--timeperiod--ensure)
* [`timeperiod_name`](#-icinga2--object--timeperiod--timeperiod_name)
* [`display_name`](#-icinga2--object--timeperiod--display_name)
* [`import`](#-icinga2--object--timeperiod--import)
* [`ranges`](#-icinga2--object--timeperiod--ranges)
* [`prefer_includes`](#-icinga2--object--timeperiod--prefer_includes)
* [`excludes`](#-icinga2--object--timeperiod--excludes)
* [`includes`](#-icinga2--object--timeperiod--includes)
* [`template`](#-icinga2--object--timeperiod--template)
* [`target`](#-icinga2--object--timeperiod--target)
* [`order`](#-icinga2--object--timeperiod--order)
* [`export`](#-icinga2--object--timeperiod--export)

##### <a name="-icinga2--object--timeperiod--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--timeperiod--timeperiod_name"></a>`timeperiod_name`

Data type: `String`

Set the Icinga 2 name of the timeperiod object.

Default value: `$title`

##### <a name="-icinga2--object--timeperiod--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the time period.

Default value: `undef`

##### <a name="-icinga2--object--timeperiod--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `['legacy-timeperiod']`

##### <a name="-icinga2--object--timeperiod--ranges"></a>`ranges`

Data type: `Optional[Hash]`

A dictionary containing information which days and durations apply to this
timeperiod.

Default value: `undef`

##### <a name="-icinga2--object--timeperiod--prefer_includes"></a>`prefer_includes`

Data type: `Optional[Boolean]`

Boolean whether to prefer timeperiods includes or excludes.

Default value: `undef`

##### <a name="-icinga2--object--timeperiod--excludes"></a>`excludes`

Data type: `Optional[Array]`

An array of timeperiods, which should exclude from your timerange.

Default value: `undef`

##### <a name="-icinga2--object--timeperiod--includes"></a>`includes`

Data type: `Optional[Array]`

An array of timeperiods, which should include into your timerange

Default value: `undef`

##### <a name="-icinga2--object--timeperiod--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--timeperiod--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store this object in. File will be declared on the first run.

##### <a name="-icinga2--object--timeperiod--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to control the position in the target file, sorted alpha numeric.

Default value: `35`

##### <a name="-icinga2--object--timeperiod--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--user"></a>`icinga2::object::user`

Manage Icinga 2 user objects.

#### Parameters

The following parameters are available in the `icinga2::object::user` defined type:

* [`ensure`](#-icinga2--object--user--ensure)
* [`user_name`](#-icinga2--object--user--user_name)
* [`display_name`](#-icinga2--object--user--display_name)
* [`email`](#-icinga2--object--user--email)
* [`pager`](#-icinga2--object--user--pager)
* [`vars`](#-icinga2--object--user--vars)
* [`groups`](#-icinga2--object--user--groups)
* [`enable_notifications`](#-icinga2--object--user--enable_notifications)
* [`period`](#-icinga2--object--user--period)
* [`types`](#-icinga2--object--user--types)
* [`states`](#-icinga2--object--user--states)
* [`template`](#-icinga2--object--user--template)
* [`import`](#-icinga2--object--user--import)
* [`target`](#-icinga2--object--user--target)
* [`order`](#-icinga2--object--user--order)
* [`export`](#-icinga2--object--user--export)

##### <a name="-icinga2--object--user--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--user--user_name"></a>`user_name`

Data type: `String`

Set the Icinga 2 name of the user object.

Default value: `$title`

##### <a name="-icinga2--object--user--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the user.

Default value: `undef`

##### <a name="-icinga2--object--user--email"></a>`email`

Data type: `Optional[String]`

An email string for this user. Useful for notification commands.

Default value: `undef`

##### <a name="-icinga2--object--user--pager"></a>`pager`

Data type: `Optional[String]`

A pager string for this user. Useful for notification commands.

Default value: `undef`

##### <a name="-icinga2--object--user--vars"></a>`vars`

Data type: `Optional[Icinga2::CustomAttributes]`

A dictionary containing custom attributes that are specific to this service,
a string to do operations on this dictionary or an array for multiple use
of custom attributes.

Default value: `undef`

##### <a name="-icinga2--object--user--groups"></a>`groups`

Data type: `Optional[Array]`

An array of group names.

Default value: `undef`

##### <a name="-icinga2--object--user--enable_notifications"></a>`enable_notifications`

Data type: `Optional[Boolean]`

Whether notifications are enabled for this user.

Default value: `undef`

##### <a name="-icinga2--object--user--period"></a>`period`

Data type: `Optional[String]`

The name of a time period which determines when a notification for this user
should be triggered.

Default value: `undef`

##### <a name="-icinga2--object--user--types"></a>`types`

Data type: `Optional[Array]`

A set of type filters when this notification should be triggered.
everything is matched.

Default value: `undef`

##### <a name="-icinga2--object--user--states"></a>`states`

Data type: `Optional[Array]`

A set of state filters when this notification should be triggered.

Default value: `undef`

##### <a name="-icinga2--object--user--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--user--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--user--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--user--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `75`

##### <a name="-icinga2--object--user--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--usergroup"></a>`icinga2::object::usergroup`

Manage Icinga 2 usergroup objects.

#### Parameters

The following parameters are available in the `icinga2::object::usergroup` defined type:

* [`ensure`](#-icinga2--object--usergroup--ensure)
* [`usergroup_name`](#-icinga2--object--usergroup--usergroup_name)
* [`display_name`](#-icinga2--object--usergroup--display_name)
* [`groups`](#-icinga2--object--usergroup--groups)
* [`assign`](#-icinga2--object--usergroup--assign)
* [`ignore`](#-icinga2--object--usergroup--ignore)
* [`template`](#-icinga2--object--usergroup--template)
* [`import`](#-icinga2--object--usergroup--import)
* [`target`](#-icinga2--object--usergroup--target)
* [`order`](#-icinga2--object--usergroup--order)
* [`export`](#-icinga2--object--usergroup--export)

##### <a name="-icinga2--object--usergroup--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--usergroup--usergroup_name"></a>`usergroup_name`

Data type: `String`

Set the Icinga 2 name of the usergroup object.

Default value: `$title`

##### <a name="-icinga2--object--usergroup--display_name"></a>`display_name`

Data type: `Optional[String]`

A short description of the service group.

Default value: `undef`

##### <a name="-icinga2--object--usergroup--groups"></a>`groups`

Data type: `Array`

An array of nested group names.

Default value: `[]`

##### <a name="-icinga2--object--usergroup--assign"></a>`assign`

Data type: `Array`

Assign user group members using the group assign rules.

Default value: `[]`

##### <a name="-icinga2--object--usergroup--ignore"></a>`ignore`

Data type: `Array`

Exclude users using the group ignore rules.

Default value: `[]`

##### <a name="-icinga2--object--usergroup--template"></a>`template`

Data type: `Boolean`

Set to true creates a template instead of an object.

Default value: `false`

##### <a name="-icinga2--object--usergroup--import"></a>`import`

Data type: `Array`

Sorted List of templates to include.

Default value: `[]`

##### <a name="-icinga2--object--usergroup--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Destination config file to store in this object. File will be declared the
first time.

##### <a name="-icinga2--object--usergroup--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to set the position in the target file, sorted alpha numeric.

Default value: `80`

##### <a name="-icinga2--object--usergroup--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

### <a name="icinga2--object--zone"></a>`icinga2::object::zone`

Manage Icinga 2 zone objects.

#### Parameters

The following parameters are available in the `icinga2::object::zone` defined type:

* [`ensure`](#-icinga2--object--zone--ensure)
* [`zone_name`](#-icinga2--object--zone--zone_name)
* [`endpoints`](#-icinga2--object--zone--endpoints)
* [`parent`](#-icinga2--object--zone--parent)
* [`global`](#-icinga2--object--zone--global)
* [`target`](#-icinga2--object--zone--target)
* [`order`](#-icinga2--object--zone--order)
* [`export`](#-icinga2--object--zone--export)

##### <a name="-icinga2--object--zone--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Set to present enables the object, absent disables it.

Default value: `present`

##### <a name="-icinga2--object--zone--zone_name"></a>`zone_name`

Data type: `String`

Set the Icinga 2 name of the zone object.

Default value: `$title`

##### <a name="-icinga2--object--zone--endpoints"></a>`endpoints`

Data type: `Array`

List of endpoints belong to this zone.

Default value: `[]`

##### <a name="-icinga2--object--zone--parent"></a>`parent`

Data type: `Optional[String]`

Parent zone to this zone.

Default value: `undef`

##### <a name="-icinga2--object--zone--global"></a>`global`

Data type: `Boolean`

If set to true, a global zone is defined and the parameter endpoints
and parent are ignored.

Default value: `false`

##### <a name="-icinga2--object--zone--target"></a>`target`

Data type: `Optional[Stdlib::Absolutepath]`

Destination config file to store in this object. File will be declared at the
first time.

Default value: `undef`

##### <a name="-icinga2--object--zone--order"></a>`order`

Data type: `Variant[String, Integer]`

String or integer to control the position in the target file, sorted alpha numeric.

Default value: `45`

##### <a name="-icinga2--object--zone--export"></a>`export`

Data type: `Variant[Array[String], String]`

Export object to destination, collected by class `icinga2::query_objects`.

Default value: `[]`

## Functions

### <a name="icinga2--cert"></a>`icinga2::cert`

Type: Puppet Language

Choose the path of tls key, cert and ca file.

#### `icinga2::cert(String $name, Optional[Stdlib::Absolutepath] $key_file = undef, Optional[Stdlib::Absolutepath] $cert_file = undef, Optional[Stdlib::Absolutepath] $cacert_file = undef, Optional[Variant[String, Sensitive[String]]] $key = undef, Optional[String] $cert = undef, Optional[String] $cacert = undef)`

The icinga2::cert function.

Returns: `Hash` Returned hash includes all paths and the key, cert and cacert.

##### `name`

Data type: `String`



##### `key_file`

Data type: `Optional[Stdlib::Absolutepath]`



##### `cert_file`

Data type: `Optional[Stdlib::Absolutepath]`



##### `cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`



##### `key`

Data type: `Optional[Variant[String, Sensitive[String]]]`



##### `cert`

Data type: `Optional[String]`



##### `cacert`

Data type: `Optional[String]`



### <a name="icinga2--db--connect"></a>`icinga2::db::connect`

Type: Puppet Language

This function returns a string to connect databases
with or without TLS information.

#### `icinga2::db::connect(Struct[{
      type     => Enum['pgsql','mysql','mariadb'],
      host     => Stdlib::Host,
      port     => Optional[Stdlib::Port],
      database => String,
      username => String,
      password => Optional[Variant[String, Sensitive[String]]],
  }] $db, Hash[String, Any] $tls, Optional[Boolean] $use_tls = undef, Optional[Enum['verify-full', 'verify-ca']] $ssl_mode = undef)`

The icinga2::db::connect function.

Returns: `String` Connection string to connect database.

##### `db`

Data type:

```puppet
Struct[{
      type     => Enum['pgsql','mysql','mariadb'],
      host     => Stdlib::Host,
      port     => Optional[Stdlib::Port],
      database => String,
      username => String,
      password => Optional[Variant[String, Sensitive[String]]],
  }]
```

Data hash with database information.

##### `tls`

Data type: `Hash[String, Any]`

Data hash with TLS connection information.

##### `use_tls`

Data type: `Optional[Boolean]`

Wether or not to use TLS encryption.

##### `ssl_mode`

Data type: `Optional[Enum['verify-full', 'verify-ca']]`

Enable SSL connection mode.

### <a name="icinga2--icinga2_attributes"></a>`icinga2::icinga2_attributes`

Type: Ruby 4.x API

Calls the simple parser  to decide what to quote.
For more information, see lib/puppet_x/icinga2/utils.rb.

#### `icinga2::icinga2_attributes(Hash $attrs, Array $globals, Hash $constants, Optional[Numeric] $indent)`

The icinga2::icinga2_attributes function.

Returns: `String` Parsed attributes as String.

##### `attrs`

Data type: `Hash`

Object attributes to parse.

##### `globals`

Data type: `Array`

A list of addational reserved words.

##### `constants`

Data type: `Hash`

A hash of additional constants.

##### `indent`

Data type: `Optional[Numeric]`

Indent to use.

### <a name="icinga2--icinga2_ticket_id"></a>`icinga2::icinga2_ticket_id`

Type: Ruby 4.x API

Summarise what the function does here

#### `icinga2::icinga2_ticket_id(String $cn, Variant[String, Sensitive[String]] $salt)`

The icinga2::icinga2_ticket_id function.

Returns: `String` Calculated ticket to receive a certificate.

##### `cn`

Data type: `String`

The common name of the Icinga host certificate.

##### `salt`

Data type: `Variant[String, Sensitive[String]]`

The ticket salt of the Icinga CA.

### <a name="icinga2--newline"></a>`icinga2::newline`

Type: Puppet Language

Replace newlines for Windows systems.

#### `icinga2::newline(Optional[String] $text)`

The icinga2::newline function.

Returns: `String` Text with correct newlines.

##### `text`

Data type: `Optional[String]`



### <a name="icinga2--parse"></a>`icinga2::parse`

Type: Puppet Language

The icinga2::parse function.

#### `icinga2::parse(Hash[String, Any] $attrs, Integer $indent = 0, Array[String] $reserved = [], Hash[String, Any] $constants = {})`

The icinga2::parse function.

Returns: `Any` The parsed string.

##### `attrs`

Data type: `Hash[String, Any]`



##### `indent`

Data type: `Integer`



##### `reserved`

Data type: `Array[String]`



##### `constants`

Data type: `Hash[String, Any]`



### <a name="icinga2--unwrap"></a>`icinga2::unwrap`

Type: Puppet Language

This function returns an unwrap string if necessary.

#### `icinga2::unwrap(Optional[Variant[String, Sensitive[String]]] $arg = undef)`

The icinga2::unwrap function.

Returns: `Any` The unwraped string.

##### `arg`

Data type: `Optional[Variant[String, Sensitive[String]]]`



## Data types

### <a name="Icinga2--BasicAuth"></a>`Icinga2::BasicAuth`

A strict type for basic authentication

Alias of

```puppet
Struct[{
    'username' => String,
    'password' => Variant[String, Sensitive[String]],
}]
```

### <a name="Icinga2--CustomAttributes"></a>`Icinga2::CustomAttributes`

A type for the structure of custom attributes

Alias of `Optional[Variant[String, Array[Variant[String, Hash]], Hash]]`

### <a name="Icinga2--Fingerprint"></a>`Icinga2::Fingerprint`

Type for certificate fingerprints
SHA1: 160 bit (20 byte) digest
SHA256: 256 bit (32 byte) digest

Alias of `Pattern[/^([0-9a-fA-F]{2}\:){19}(([0-9a-fA-F]{2}\:){12})?[0-9a-fA-F]{2}$/]`

### <a name="Icinga2--IdoCleanup"></a>`Icinga2::IdoCleanup`

A type for the structure of settings to cleanup IDO databases

Alias of

```puppet
Hash[Enum[
    'acknowledgements_age',
    'commenthistory_age',
    'contactnotifications_age',
    'contactnotificationmethods_age',
    'downtimehistory_age',
    'eventhandlers_age',
    'externalcommands_age',
    'flappinghistory_age',
    'hostchecks_age',
    'logentries_age',
    'notifications_age',
    'processevents_age',
    'statehistory_age',
    'servicechecks_age',
    'systemcommands_age',
  ], String]
```

### <a name="Icinga2--Interval"></a>`Icinga2::Interval`

A strict type for intervals

Alias of `Variant[Integer, Pattern[/\A\d+\.?\d*[d|h|m|s]?\Z/, /\A\$.+\$\Z/, /\A(host|service)\..+/]]`

### <a name="Icinga2--LogFacility"></a>`Icinga2::LogFacility`

A strict type of syslog facilities

Alias of

```puppet
Variant[Enum[
    'LOG_AUTH',
    'LOG_AUTHPRIV',
    'LOG_CRON',
    'LOG_DAEMON',
    'LOG_FTP',
    'LOG_KERN',
    'LOG_LPR',
    'LOG_MAIL',
    'LOG_NEWS',
    'LOG_SYSLOG',
    'LOG_USER',
    'LOG_UUCP'
  ], Pattern[/^LOG_LOCAL[0-7]$/]]
```

### <a name="Icinga2--LogSeverity"></a>`Icinga2::LogSeverity`

A strict type for log levels

Alias of `Enum['debug', 'information', 'notice', 'warning', 'critical']`

